#version 100 sc_convert_to 300 es
#if defined VERTEX_SHADER
#define SC_REMOVE_ENVMAP_FROM_AMBIENT_LIGHT_STRUCT




#include <std2.glsl>
#include <std2_vs.glsl>
#include <std2_fs.glsl>
#include <std2_texture.glsl>



varying vec4 varColor;
attribute vec4 color;

vec4 _2807;
mat3 _2809;
vec2 _2822;
vec3 _2833;

void ngsVertexShaderEnd(sc_Vertex_t v,vec3 WorldPosition,vec3 WorldNormal,vec3 WorldTangent,vec4 ScreenPosition)
{
varPos=WorldPosition;
varNormal=normalize(WorldNormal);
vec3 _2054=normalize(WorldTangent);
varTangent=vec4(_2054.x,_2054.y,_2054.z,varTangent.w);
varTangent.w=tangent.w;
#if (UseViewSpaceDepthVariant&&((sc_OITDepthGatherPass||sc_OITCompositingPass)||sc_OITDepthBoundsPass))
{
vec4 param=v.position;
varViewSpaceDepth=-sc_ObjectToView(param).z;
}
#endif
vec4 _2845;
#if (sc_RenderingSpace==3)
{
_2845=ScreenPosition;
}
#else
{
vec4 _2846;
#if (sc_RenderingSpace==4)
{
_2846=(sc_ModelViewMatrixArray[sc_GetStereoViewIndex()]*v.position)*vec4(1.0/sc_Camera.aspect,1.0,1.0,1.0);
}
#else
{
vec4 _2847;
#if (sc_RenderingSpace==2)
{
_2847=sc_ViewProjectionMatrixArray[sc_GetStereoViewIndex()]*vec4(varPos,1.0);
}
#else
{
vec4 _2848;
#if (sc_RenderingSpace==1)
{
_2848=sc_ViewProjectionMatrixArray[sc_GetStereoViewIndex()]*vec4(varPos,1.0);
}
#else
{
_2848=vec4(0.0);
}
#endif
_2847=_2848;
}
#endif
_2846=_2847;
}
#endif
_2845=_2846;
}
#endif
varPackedTex=vec4(v.texture0,v.texture1);
#if (sc_ProjectiveShadowsReceiver)
{
vec4 param_1=v.position;
varShadowTex=getProjectedTexCoords(param_1);
}
#endif
vec4 _2849;
#if (sc_DepthBufferMode==1)
{
vec4 _2784=_2845;
_2784.z=((log2(max(sc_Camera.clipPlanes.x,1.0+_2845.w))*(2.0/log2(sc_Camera.clipPlanes.y+1.0)))-1.0)*_2845.w;
_2849=_2784;
}
#else
{
_2849=_2845;
}
#endif
gl_Position=_2849;
}

void main()
{
sc_Vertex_t _2644=sc_LoadVertexAttributes();
sc_BlendVertex(_2644);
sc_Vertex_t _2645=_2644;
sc_SkinVertex(_2645);
sc_Vertex_t _2653=_2645;
#if (sc_RenderingSpace==3)
{
varPos=vec3(0.0);
varNormal=_2653.normal;
varTangent=vec4(_2653.tangent.x,_2653.tangent.y,_2653.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==4)
{
varPos=vec3(0.0);
varNormal=_2653.normal;
varTangent=vec4(_2653.tangent.x,_2653.tangent.y,_2653.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==2)
{
varPos=_2653.position.xyz;
varNormal=_2653.normal;
varTangent=vec4(_2653.tangent.x,_2653.tangent.y,_2653.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==1)
{
varPos=(sc_ModelMatrix*_2653.position).xyz;
varNormal=sc_NormalMatrix*_2653.normal;
vec3 _2670=sc_NormalMatrix*_2653.tangent;
varTangent=vec4(_2670.x,_2670.y,_2670.z,varTangent.w);
}
#endif
}
#endif
}
#endif
}
#endif
varColor=color;
sc_Vertex_t param=_2653;
vec3 param_1=varPos;
vec3 param_2=varNormal;
vec3 param_3=varTangent.xyz;
vec4 param_4=_2653.position;
ngsVertexShaderEnd(param,param_1,param_2,param_3,param_4);
}

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#define SC_REMOVE_ENVMAP_FROM_AMBIENT_LIGHT_STRUCT




#include <std2.glsl>
#include <std2_vs.glsl>
#include <std2_fs.glsl>
#include <std2_texture.glsl>

struct ssGlobals
{
float gTimeElapsed;
float gTimeDelta;
float gTimeElapsedShifted;
vec2 Surface_UVCoord0;
};

#ifndef BLEND_MODE_LIGHTEN
#define BLEND_MODE_LIGHTEN 0
#elif BLEND_MODE_LIGHTEN==1
#undef BLEND_MODE_LIGHTEN
#define BLEND_MODE_LIGHTEN 1
#endif
#ifndef BLEND_MODE_DARKEN
#define BLEND_MODE_DARKEN 0
#elif BLEND_MODE_DARKEN==1
#undef BLEND_MODE_DARKEN
#define BLEND_MODE_DARKEN 1
#endif
#ifndef BLEND_MODE_DIVIDE
#define BLEND_MODE_DIVIDE 0
#elif BLEND_MODE_DIVIDE==1
#undef BLEND_MODE_DIVIDE
#define BLEND_MODE_DIVIDE 1
#endif
#ifndef BLEND_MODE_AVERAGE
#define BLEND_MODE_AVERAGE 0
#elif BLEND_MODE_AVERAGE==1
#undef BLEND_MODE_AVERAGE
#define BLEND_MODE_AVERAGE 1
#endif
#ifndef BLEND_MODE_SUBTRACT
#define BLEND_MODE_SUBTRACT 0
#elif BLEND_MODE_SUBTRACT==1
#undef BLEND_MODE_SUBTRACT
#define BLEND_MODE_SUBTRACT 1
#endif
#ifndef BLEND_MODE_DIFFERENCE
#define BLEND_MODE_DIFFERENCE 0
#elif BLEND_MODE_DIFFERENCE==1
#undef BLEND_MODE_DIFFERENCE
#define BLEND_MODE_DIFFERENCE 1
#endif
#ifndef BLEND_MODE_NEGATION
#define BLEND_MODE_NEGATION 0
#elif BLEND_MODE_NEGATION==1
#undef BLEND_MODE_NEGATION
#define BLEND_MODE_NEGATION 1
#endif
#ifndef BLEND_MODE_EXCLUSION
#define BLEND_MODE_EXCLUSION 0
#elif BLEND_MODE_EXCLUSION==1
#undef BLEND_MODE_EXCLUSION
#define BLEND_MODE_EXCLUSION 1
#endif
#ifndef BLEND_MODE_OVERLAY
#define BLEND_MODE_OVERLAY 0
#elif BLEND_MODE_OVERLAY==1
#undef BLEND_MODE_OVERLAY
#define BLEND_MODE_OVERLAY 1
#endif
#ifndef BLEND_MODE_SOFT_LIGHT
#define BLEND_MODE_SOFT_LIGHT 0
#elif BLEND_MODE_SOFT_LIGHT==1
#undef BLEND_MODE_SOFT_LIGHT
#define BLEND_MODE_SOFT_LIGHT 1
#endif
#ifndef BLEND_MODE_HARD_LIGHT
#define BLEND_MODE_HARD_LIGHT 0
#elif BLEND_MODE_HARD_LIGHT==1
#undef BLEND_MODE_HARD_LIGHT
#define BLEND_MODE_HARD_LIGHT 1
#endif
#ifndef BLEND_MODE_COLOR_DODGE
#define BLEND_MODE_COLOR_DODGE 0
#elif BLEND_MODE_COLOR_DODGE==1
#undef BLEND_MODE_COLOR_DODGE
#define BLEND_MODE_COLOR_DODGE 1
#endif
#ifndef BLEND_MODE_COLOR_BURN
#define BLEND_MODE_COLOR_BURN 0
#elif BLEND_MODE_COLOR_BURN==1
#undef BLEND_MODE_COLOR_BURN
#define BLEND_MODE_COLOR_BURN 1
#endif
#ifndef BLEND_MODE_LINEAR_LIGHT
#define BLEND_MODE_LINEAR_LIGHT 0
#elif BLEND_MODE_LINEAR_LIGHT==1
#undef BLEND_MODE_LINEAR_LIGHT
#define BLEND_MODE_LINEAR_LIGHT 1
#endif
#ifndef BLEND_MODE_VIVID_LIGHT
#define BLEND_MODE_VIVID_LIGHT 0
#elif BLEND_MODE_VIVID_LIGHT==1
#undef BLEND_MODE_VIVID_LIGHT
#define BLEND_MODE_VIVID_LIGHT 1
#endif
#ifndef BLEND_MODE_PIN_LIGHT
#define BLEND_MODE_PIN_LIGHT 0
#elif BLEND_MODE_PIN_LIGHT==1
#undef BLEND_MODE_PIN_LIGHT
#define BLEND_MODE_PIN_LIGHT 1
#endif
#ifndef BLEND_MODE_HARD_MIX
#define BLEND_MODE_HARD_MIX 0
#elif BLEND_MODE_HARD_MIX==1
#undef BLEND_MODE_HARD_MIX
#define BLEND_MODE_HARD_MIX 1
#endif
#ifndef BLEND_MODE_HARD_REFLECT
#define BLEND_MODE_HARD_REFLECT 0
#elif BLEND_MODE_HARD_REFLECT==1
#undef BLEND_MODE_HARD_REFLECT
#define BLEND_MODE_HARD_REFLECT 1
#endif
#ifndef BLEND_MODE_HARD_GLOW
#define BLEND_MODE_HARD_GLOW 0
#elif BLEND_MODE_HARD_GLOW==1
#undef BLEND_MODE_HARD_GLOW
#define BLEND_MODE_HARD_GLOW 1
#endif
#ifndef BLEND_MODE_HARD_PHOENIX
#define BLEND_MODE_HARD_PHOENIX 0
#elif BLEND_MODE_HARD_PHOENIX==1
#undef BLEND_MODE_HARD_PHOENIX
#define BLEND_MODE_HARD_PHOENIX 1
#endif
#ifndef BLEND_MODE_HUE
#define BLEND_MODE_HUE 0
#elif BLEND_MODE_HUE==1
#undef BLEND_MODE_HUE
#define BLEND_MODE_HUE 1
#endif
#ifndef BLEND_MODE_SATURATION
#define BLEND_MODE_SATURATION 0
#elif BLEND_MODE_SATURATION==1
#undef BLEND_MODE_SATURATION
#define BLEND_MODE_SATURATION 1
#endif
#ifndef BLEND_MODE_COLOR
#define BLEND_MODE_COLOR 0
#elif BLEND_MODE_COLOR==1
#undef BLEND_MODE_COLOR
#define BLEND_MODE_COLOR 1
#endif
#ifndef BLEND_MODE_LUMINOSITY
#define BLEND_MODE_LUMINOSITY 0
#elif BLEND_MODE_LUMINOSITY==1
#undef BLEND_MODE_LUMINOSITY
#define BLEND_MODE_LUMINOSITY 1
#endif
#ifndef baseTextureHasSwappedViews
#define baseTextureHasSwappedViews 0
#elif baseTextureHasSwappedViews==1
#undef baseTextureHasSwappedViews
#define baseTextureHasSwappedViews 1
#endif
#ifndef baseTextureLayout
#define baseTextureLayout 0
#endif
#ifndef maskTexHasSwappedViews
#define maskTexHasSwappedViews 0
#elif maskTexHasSwappedViews==1
#undef maskTexHasSwappedViews
#define maskTexHasSwappedViews 1
#endif
#ifndef maskTexLayout
#define maskTexLayout 0
#endif
#ifndef Tweak_N11
#define Tweak_N11 0
#elif Tweak_N11==1
#undef Tweak_N11
#define Tweak_N11 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTexture
#define SC_SOFTWARE_WRAP_MODE_U_baseTexture -1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTexture
#define SC_USE_CLAMP_TO_BORDER_baseTexture 0
#elif SC_USE_CLAMP_TO_BORDER_baseTexture==1
#undef SC_USE_CLAMP_TO_BORDER_baseTexture
#define SC_USE_CLAMP_TO_BORDER_baseTexture 1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTexture
#define SC_USE_UV_MIN_MAX_baseTexture 0
#elif SC_USE_UV_MIN_MAX_baseTexture==1
#undef SC_USE_UV_MIN_MAX_baseTexture
#define SC_USE_UV_MIN_MAX_baseTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTexture
#define SC_SOFTWARE_WRAP_MODE_V_baseTexture -1
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTexture
#define SC_USE_UV_TRANSFORM_baseTexture 0
#elif SC_USE_UV_TRANSFORM_baseTexture==1
#undef SC_USE_UV_TRANSFORM_baseTexture
#define SC_USE_UV_TRANSFORM_baseTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTex
#define SC_SOFTWARE_WRAP_MODE_U_maskTex -1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTex
#define SC_USE_CLAMP_TO_BORDER_maskTex 0
#elif SC_USE_CLAMP_TO_BORDER_maskTex==1
#undef SC_USE_CLAMP_TO_BORDER_maskTex
#define SC_USE_CLAMP_TO_BORDER_maskTex 1
#endif
#ifndef SC_USE_UV_MIN_MAX_maskTex
#define SC_USE_UV_MIN_MAX_maskTex 0
#elif SC_USE_UV_MIN_MAX_maskTex==1
#undef SC_USE_UV_MIN_MAX_maskTex
#define SC_USE_UV_MIN_MAX_maskTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTex
#define SC_SOFTWARE_WRAP_MODE_V_maskTex -1
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTex
#define SC_USE_UV_TRANSFORM_maskTex 0
#elif SC_USE_UV_TRANSFORM_maskTex==1
#undef SC_USE_UV_TRANSFORM_maskTex
#define SC_USE_UV_TRANSFORM_maskTex 1
#endif

uniform mediump sampler2D sc_OITFilteredDepthBoundsTexture;
uniform highp sampler2D sc_OITFrontDepthTexture;
uniform mediump sampler2D sc_OITDepthHigh0;
uniform mediump sampler2D sc_OITDepthLow0;
uniform mediump sampler2D sc_OITAlpha0;
uniform mediump sampler2D sc_OITDepthHigh1;
uniform mediump sampler2D sc_OITDepthLow1;
uniform mediump sampler2D sc_OITAlpha1;
uniform float alphaTestThreshold;
uniform vec4 baseTextureDims;
uniform mediump sampler2DArray baseTextureArrSC;
uniform mediump sampler2D baseTexture;
uniform vec4 maskTexDims;
uniform mediump sampler2DArray maskTexArrSC;
uniform mediump sampler2D maskTex;
uniform vec4 baseTextureUvMinMax;
uniform mat3 baseTextureTransform;
uniform vec4 baseTextureBorderColor;
uniform vec4 baseColor;
uniform vec4 maskTexUvMinMax;
uniform mat3 maskTexTransform;
uniform vec4 maskTexBorderColor;
uniform bool overrideTimeEnable;
uniform float overrideTimeElapsed;
uniform float overrideTimeDelta;

varying vec4 varColor;

float _7096;
vec4 _7175;
vec4 _7196;
vec4 _7364;
float _7422;

int baseTextureGetStereoViewIndex()
{
#if (baseTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex();
}
#else
{
return sc_GetStereoViewIndex();
}
#endif
}

vec4 baseTextureSampleViewIndexBias(vec2 uv,int viewIndex,float bias)
{
#if (baseTextureLayout==2)
{
vec2 param=baseTextureDims.xy;
vec2 param_1=uv;
int param_2=baseTextureLayout;
int param_3=viewIndex;
float param_4=bias;
return sc_SampleView(baseTextureArrSC,param,param_1,param_2,param_3,param_4);
}
#else
{
vec2 param_5=baseTextureDims.xy;
vec2 param_6=uv;
int param_7=baseTextureLayout;
int param_8=viewIndex;
float param_9=bias;
return sc_SampleView(baseTexture,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

void Node19_Texture_2D_Parameter(out vec4 Output,ssGlobals Globals)
{
vec2 _4304=Globals.Surface_UVCoord0;
vec2 _7366;
float _7369;
#if ((SC_SOFTWARE_WRAP_MODE_U_baseTexture==0)||(SC_SOFTWARE_WRAP_MODE_U_baseTexture==3))
{
float _4315=clamp(_4304.x,0.0,1.0);
float _7372;
#if (SC_USE_CLAMP_TO_BORDER_baseTexture&&(!SC_USE_UV_MIN_MAX_baseTexture))
{
_7372=step(abs(_4304.x-_4315),1e-05);
}
#else
{
_7372=1.0;
}
#endif
vec2 _7042=_4304;
_7042.x=_4315;
_7369=_7372;
_7366=_7042;
}
#else
{
vec2 _7367;
#if (SC_SOFTWARE_WRAP_MODE_U_baseTexture==1)
{
vec2 _7038=_4304;
_7038.x=fract(_4304.x);
_7367=_7038;
}
#else
{
vec2 _7368;
#if (SC_SOFTWARE_WRAP_MODE_U_baseTexture==2)
{
float _4348=fract(_4304.x);
vec2 _7035=_4304;
_7035.x=mix(_4348,1.0-_4348,clamp(step(0.25,fract((_4304.x-_4348)*0.5)),0.0,1.0));
_7368=_7035;
}
#else
{
_7368=_4304;
}
#endif
_7367=_7368;
}
#endif
_7369=1.0;
_7366=_7367;
}
#endif
vec2 _7374;
float _7377;
#if ((SC_SOFTWARE_WRAP_MODE_V_baseTexture==0)||(SC_SOFTWARE_WRAP_MODE_V_baseTexture==3))
{
float _4376=clamp(_7366.y,0.0,1.0);
float _7380;
#if (SC_USE_CLAMP_TO_BORDER_baseTexture&&(!SC_USE_UV_MIN_MAX_baseTexture))
{
_7380=_7369*step(abs(_7366.y-_4376),1e-05);
}
#else
{
_7380=_7369;
}
#endif
vec2 _7053=_7366;
_7053.y=_4376;
_7377=_7380;
_7374=_7053;
}
#else
{
vec2 _7375;
#if (SC_SOFTWARE_WRAP_MODE_V_baseTexture==1)
{
vec2 _7049=_7366;
_7049.y=fract(_7366.y);
_7375=_7049;
}
#else
{
vec2 _7376;
#if (SC_SOFTWARE_WRAP_MODE_V_baseTexture==2)
{
float _4406=fract(_7366.y);
vec2 _7046=_7366;
_7046.y=mix(_4406,1.0-_4406,clamp(step(0.25,fract((_7366.y-_4406)*0.5)),0.0,1.0));
_7376=_7046;
}
#else
{
_7376=_7366;
}
#endif
_7375=_7376;
}
#endif
_7377=_7369;
_7374=_7375;
}
#endif
vec2 _7384;
float _7387;
#if (SC_USE_UV_MIN_MAX_baseTexture)
{
float _4434=clamp(_7374.x,baseTextureUvMinMax.x,baseTextureUvMinMax.z);
float _7382;
#if (SC_USE_CLAMP_TO_BORDER_baseTexture)
{
_7382=_7377*step(abs(_7374.x-_4434),1e-05);
}
#else
{
_7382=_7377;
}
#endif
vec2 _7057=_7374;
_7057.x=_4434;
float _4454=clamp(_7374.y,baseTextureUvMinMax.y,baseTextureUvMinMax.w);
float _7388;
#if (SC_USE_CLAMP_TO_BORDER_baseTexture)
{
_7388=_7382*step(abs(_7374.y-_4454),1e-05);
}
#else
{
_7388=_7382;
}
#endif
vec2 _7061=_7057;
_7061.y=_4454;
_7387=_7388;
_7384=_7061;
}
#else
{
_7387=_7377;
_7384=_7374;
}
#endif
vec2 _7385;
#if (SC_USE_UV_TRANSFORM_baseTexture)
{
_7385=vec2((baseTextureTransform*vec3(_7384,1.0)).xy);
}
#else
{
_7385=_7384;
}
#endif
vec2 param=_7385;
vec2 _5041=quantizeUV(param);
int _5042=baseTextureGetStereoViewIndex();
float _5043=0.0;
vec4 _5049=baseTextureSampleViewIndexBias(_5041,_5042,_5043);
vec4 _7389;
#if (SC_USE_CLAMP_TO_BORDER_baseTexture)
{
_7389=mix(baseTextureBorderColor,_5049,vec4(_7387));
}
#else
{
_7389=_5049;
}
#endif
Output=_7389;
}

int maskTexGetStereoViewIndex()
{
#if (maskTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex();
}
#else
{
return sc_GetStereoViewIndex();
}
#endif
}

vec4 maskTexSampleViewIndexBias(vec2 uv,int viewIndex,float bias)
{
#if (maskTexLayout==2)
{
vec2 param=maskTexDims.xy;
vec2 param_1=uv;
int param_2=maskTexLayout;
int param_3=viewIndex;
float param_4=bias;
return sc_SampleView(maskTexArrSC,param,param_1,param_2,param_3,param_4);
}
#else
{
vec2 param_5=maskTexDims.xy;
vec2 param_6=uv;
int param_7=maskTexLayout;
int param_8=viewIndex;
float param_9=bias;
return sc_SampleView(maskTex,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

void Node2_Texture_2D_Parameter(out vec4 Output,ssGlobals Globals)
{
vec2 _4522=Globals.Surface_UVCoord0;
vec2 _7391;
float _7394;
#if ((SC_SOFTWARE_WRAP_MODE_U_maskTex==0)||(SC_SOFTWARE_WRAP_MODE_U_maskTex==3))
{
float _4533=clamp(_4522.x,0.0,1.0);
float _7397;
#if (SC_USE_CLAMP_TO_BORDER_maskTex&&(!SC_USE_UV_MIN_MAX_maskTex))
{
_7397=step(abs(_4522.x-_4533),1e-05);
}
#else
{
_7397=1.0;
}
#endif
vec2 _7072=_4522;
_7072.x=_4533;
_7394=_7397;
_7391=_7072;
}
#else
{
vec2 _7392;
#if (SC_SOFTWARE_WRAP_MODE_U_maskTex==1)
{
vec2 _7068=_4522;
_7068.x=fract(_4522.x);
_7392=_7068;
}
#else
{
vec2 _7393;
#if (SC_SOFTWARE_WRAP_MODE_U_maskTex==2)
{
float _4565=fract(_4522.x);
vec2 _7065=_4522;
_7065.x=mix(_4565,1.0-_4565,clamp(step(0.25,fract((_4522.x-_4565)*0.5)),0.0,1.0));
_7393=_7065;
}
#else
{
_7393=_4522;
}
#endif
_7392=_7393;
}
#endif
_7394=1.0;
_7391=_7392;
}
#endif
vec2 _7399;
float _7402;
#if ((SC_SOFTWARE_WRAP_MODE_V_maskTex==0)||(SC_SOFTWARE_WRAP_MODE_V_maskTex==3))
{
float _4592=clamp(_7391.y,0.0,1.0);
float _7405;
#if (SC_USE_CLAMP_TO_BORDER_maskTex&&(!SC_USE_UV_MIN_MAX_maskTex))
{
_7405=_7394*step(abs(_7391.y-_4592),1e-05);
}
#else
{
_7405=_7394;
}
#endif
vec2 _7083=_7391;
_7083.y=_4592;
_7402=_7405;
_7399=_7083;
}
#else
{
vec2 _7400;
#if (SC_SOFTWARE_WRAP_MODE_V_maskTex==1)
{
vec2 _7079=_7391;
_7079.y=fract(_7391.y);
_7400=_7079;
}
#else
{
vec2 _7401;
#if (SC_SOFTWARE_WRAP_MODE_V_maskTex==2)
{
float _4622=fract(_7391.y);
vec2 _7076=_7391;
_7076.y=mix(_4622,1.0-_4622,clamp(step(0.25,fract((_7391.y-_4622)*0.5)),0.0,1.0));
_7401=_7076;
}
#else
{
_7401=_7391;
}
#endif
_7400=_7401;
}
#endif
_7402=_7394;
_7399=_7400;
}
#endif
vec2 _7409;
float _7412;
#if (SC_USE_UV_MIN_MAX_maskTex)
{
float _4650=clamp(_7399.x,maskTexUvMinMax.x,maskTexUvMinMax.z);
float _7407;
#if (SC_USE_CLAMP_TO_BORDER_maskTex)
{
_7407=_7402*step(abs(_7399.x-_4650),1e-05);
}
#else
{
_7407=_7402;
}
#endif
vec2 _7087=_7399;
_7087.x=_4650;
float _4670=clamp(_7399.y,maskTexUvMinMax.y,maskTexUvMinMax.w);
float _7413;
#if (SC_USE_CLAMP_TO_BORDER_maskTex)
{
_7413=_7407*step(abs(_7399.y-_4670),1e-05);
}
#else
{
_7413=_7407;
}
#endif
vec2 _7091=_7087;
_7091.y=_4670;
_7412=_7413;
_7409=_7091;
}
#else
{
_7412=_7402;
_7409=_7399;
}
#endif
vec2 _7410;
#if (SC_USE_UV_TRANSFORM_maskTex)
{
_7410=vec2((maskTexTransform*vec3(_7409,1.0)).xy);
}
#else
{
_7410=_7409;
}
#endif
vec2 param=_7410;
vec2 _5050=quantizeUV(param);
int _5051=maskTexGetStereoViewIndex();
float _5052=0.0;
vec4 _5058=maskTexSampleViewIndexBias(_5050,_5051,_5052);
vec4 _7414;
#if (SC_USE_CLAMP_TO_BORDER_maskTex)
{
_7414=mix(maskTexBorderColor,_5058,vec4(_7412));
}
#else
{
_7414=_5058;
}
#endif
Output=_7414;
}

vec3 definedBlend(vec3 a,vec3 b)
{
#if (BLEND_MODE_LIGHTEN)
{
return max(a,b);
}
#else
{
#if (BLEND_MODE_DARKEN)
{
return min(a,b);
}
#else
{
#if (BLEND_MODE_DIVIDE)
{
return b/a;
}
#else
{
#if (BLEND_MODE_AVERAGE)
{
return (a+b)*0.5;
}
#else
{
#if (BLEND_MODE_SUBTRACT)
{
return max((a+b)-vec3(1.0),vec3(0.0));
}
#else
{
#if (BLEND_MODE_DIFFERENCE)
{
return abs(a-b);
}
#else
{
#if (BLEND_MODE_NEGATION)
{
return vec3(1.0)-abs((vec3(1.0)-a)-b);
}
#else
{
#if (BLEND_MODE_EXCLUSION)
{
return (a+b)-((a*2.0)*b);
}
#else
{
#if (BLEND_MODE_OVERLAY)
{
float _7171;
if (a.x<0.5)
{
_7171=(2.0*a.x)*b.x;
}
else
{
_7171=1.0-((2.0*(1.0-a.x))*(1.0-b.x));
}
float _7172;
if (a.y<0.5)
{
_7172=(2.0*a.y)*b.y;
}
else
{
_7172=1.0-((2.0*(1.0-a.y))*(1.0-b.y));
}
float _7173;
if (a.z<0.5)
{
_7173=(2.0*a.z)*b.z;
}
else
{
_7173=1.0-((2.0*(1.0-a.z))*(1.0-b.z));
}
return vec3(_7171,_7172,_7173);
}
#else
{
#if (BLEND_MODE_SOFT_LIGHT)
{
return (((vec3(1.0)-(b*2.0))*a)*a)+((a*2.0)*b);
}
#else
{
#if (BLEND_MODE_HARD_LIGHT)
{
float _7168;
if (b.x<0.5)
{
_7168=(2.0*b.x)*a.x;
}
else
{
_7168=1.0-((2.0*(1.0-b.x))*(1.0-a.x));
}
float _7169;
if (b.y<0.5)
{
_7169=(2.0*b.y)*a.y;
}
else
{
_7169=1.0-((2.0*(1.0-b.y))*(1.0-a.y));
}
float _7170;
if (b.z<0.5)
{
_7170=(2.0*b.z)*a.z;
}
else
{
_7170=1.0-((2.0*(1.0-b.z))*(1.0-a.z));
}
return vec3(_7168,_7169,_7170);
}
#else
{
#if (BLEND_MODE_COLOR_DODGE)
{
float _7165;
if (b.x==1.0)
{
_7165=b.x;
}
else
{
_7165=min(a.x/(1.0-b.x),1.0);
}
float _7166;
if (b.y==1.0)
{
_7166=b.y;
}
else
{
_7166=min(a.y/(1.0-b.y),1.0);
}
float _7167;
if (b.z==1.0)
{
_7167=b.z;
}
else
{
_7167=min(a.z/(1.0-b.z),1.0);
}
return vec3(_7165,_7166,_7167);
}
#else
{
#if (BLEND_MODE_COLOR_BURN)
{
float _7162;
if (b.x==0.0)
{
_7162=b.x;
}
else
{
_7162=max(1.0-((1.0-a.x)/b.x),0.0);
}
float _7163;
if (b.y==0.0)
{
_7163=b.y;
}
else
{
_7163=max(1.0-((1.0-a.y)/b.y),0.0);
}
float _7164;
if (b.z==0.0)
{
_7164=b.z;
}
else
{
_7164=max(1.0-((1.0-a.z)/b.z),0.0);
}
return vec3(_7162,_7163,_7164);
}
#else
{
#if (BLEND_MODE_LINEAR_LIGHT)
{
float _7159;
if (b.x<0.5)
{
_7159=max((a.x+(2.0*b.x))-1.0,0.0);
}
else
{
_7159=min(a.x+(2.0*(b.x-0.5)),1.0);
}
float _7160;
if (b.y<0.5)
{
_7160=max((a.y+(2.0*b.y))-1.0,0.0);
}
else
{
_7160=min(a.y+(2.0*(b.y-0.5)),1.0);
}
float _7161;
if (b.z<0.5)
{
_7161=max((a.z+(2.0*b.z))-1.0,0.0);
}
else
{
_7161=min(a.z+(2.0*(b.z-0.5)),1.0);
}
return vec3(_7159,_7160,_7161);
}
#else
{
#if (BLEND_MODE_VIVID_LIGHT)
{
float _7152;
if (b.x<0.5)
{
float _7151;
if ((2.0*b.x)==0.0)
{
_7151=2.0*b.x;
}
else
{
_7151=max(1.0-((1.0-a.x)/(2.0*b.x)),0.0);
}
_7152=_7151;
}
else
{
float _7150;
if ((2.0*(b.x-0.5))==1.0)
{
_7150=2.0*(b.x-0.5);
}
else
{
_7150=min(a.x/(1.0-(2.0*(b.x-0.5))),1.0);
}
_7152=_7150;
}
float _7155;
if (b.y<0.5)
{
float _7154;
if ((2.0*b.y)==0.0)
{
_7154=2.0*b.y;
}
else
{
_7154=max(1.0-((1.0-a.y)/(2.0*b.y)),0.0);
}
_7155=_7154;
}
else
{
float _7153;
if ((2.0*(b.y-0.5))==1.0)
{
_7153=2.0*(b.y-0.5);
}
else
{
_7153=min(a.y/(1.0-(2.0*(b.y-0.5))),1.0);
}
_7155=_7153;
}
float _7158;
if (b.z<0.5)
{
float _7157;
if ((2.0*b.z)==0.0)
{
_7157=2.0*b.z;
}
else
{
_7157=max(1.0-((1.0-a.z)/(2.0*b.z)),0.0);
}
_7158=_7157;
}
else
{
float _7156;
if ((2.0*(b.z-0.5))==1.0)
{
_7156=2.0*(b.z-0.5);
}
else
{
_7156=min(a.z/(1.0-(2.0*(b.z-0.5))),1.0);
}
_7158=_7156;
}
return vec3(_7152,_7155,_7158);
}
#else
{
#if (BLEND_MODE_PIN_LIGHT)
{
float _7147;
if (b.x<0.5)
{
_7147=min(a.x,2.0*b.x);
}
else
{
_7147=max(a.x,2.0*(b.x-0.5));
}
float _7148;
if (b.y<0.5)
{
_7148=min(a.y,2.0*b.y);
}
else
{
_7148=max(a.y,2.0*(b.y-0.5));
}
float _7149;
if (b.z<0.5)
{
_7149=min(a.z,2.0*b.z);
}
else
{
_7149=max(a.z,2.0*(b.z-0.5));
}
return vec3(_7147,_7148,_7149);
}
#else
{
#if (BLEND_MODE_HARD_MIX)
{
float _7140;
if (b.x<0.5)
{
float _7139;
if ((2.0*b.x)==0.0)
{
_7139=2.0*b.x;
}
else
{
_7139=max(1.0-((1.0-a.x)/(2.0*b.x)),0.0);
}
_7140=_7139;
}
else
{
float _7138;
if ((2.0*(b.x-0.5))==1.0)
{
_7138=2.0*(b.x-0.5);
}
else
{
_7138=min(a.x/(1.0-(2.0*(b.x-0.5))),1.0);
}
_7140=_7138;
}
bool _2859=_7140<0.5;
float _7143;
if (b.y<0.5)
{
float _7142;
if ((2.0*b.y)==0.0)
{
_7142=2.0*b.y;
}
else
{
_7142=max(1.0-((1.0-a.y)/(2.0*b.y)),0.0);
}
_7143=_7142;
}
else
{
float _7141;
if ((2.0*(b.y-0.5))==1.0)
{
_7141=2.0*(b.y-0.5);
}
else
{
_7141=min(a.y/(1.0-(2.0*(b.y-0.5))),1.0);
}
_7143=_7141;
}
bool _2913=_7143<0.5;
float _7146;
if (b.z<0.5)
{
float _7145;
if ((2.0*b.z)==0.0)
{
_7145=2.0*b.z;
}
else
{
_7145=max(1.0-((1.0-a.z)/(2.0*b.z)),0.0);
}
_7146=_7145;
}
else
{
float _7144;
if ((2.0*(b.z-0.5))==1.0)
{
_7144=2.0*(b.z-0.5);
}
else
{
_7144=min(a.z/(1.0-(2.0*(b.z-0.5))),1.0);
}
_7146=_7144;
}
return vec3(_2859 ? 0.0 : 1.0,_2913 ? 0.0 : 1.0,(_7146<0.5) ? 0.0 : 1.0);
}
#else
{
#if (BLEND_MODE_HARD_REFLECT)
{
float _7135;
if (b.x==1.0)
{
_7135=b.x;
}
else
{
_7135=min((a.x*a.x)/(1.0-b.x),1.0);
}
float _7136;
if (b.y==1.0)
{
_7136=b.y;
}
else
{
_7136=min((a.y*a.y)/(1.0-b.y),1.0);
}
float _7137;
if (b.z==1.0)
{
_7137=b.z;
}
else
{
_7137=min((a.z*a.z)/(1.0-b.z),1.0);
}
return vec3(_7135,_7136,_7137);
}
#else
{
#if (BLEND_MODE_HARD_GLOW)
{
float _7132;
if (a.x==1.0)
{
_7132=a.x;
}
else
{
_7132=min((b.x*b.x)/(1.0-a.x),1.0);
}
float _7133;
if (a.y==1.0)
{
_7133=a.y;
}
else
{
_7133=min((b.y*b.y)/(1.0-a.y),1.0);
}
float _7134;
if (a.z==1.0)
{
_7134=a.z;
}
else
{
_7134=min((b.z*b.z)/(1.0-a.z),1.0);
}
return vec3(_7132,_7133,_7134);
}
#else
{
#if (BLEND_MODE_HARD_PHOENIX)
{
return (min(a,b)-max(a,b))+vec3(1.0);
}
#else
{
#if (BLEND_MODE_HUE)
{
vec3 _3121=a;
vec3 _3123=b;
vec4 _7128;
if (_3121.y<_3121.z)
{
_7128=vec4(_3121.zy,-1.0,0.666667);
}
else
{
_7128=vec4(_3121.yz,0.0,-0.333333);
}
vec4 _7129;
if (_3121.x<_7128.x)
{
_7129=vec4(_7128.xy,_7422,_3121.x);
}
else
{
_7129=vec4(_3121.x,_7128.y,_7422,_7128.x);
}
float _6613=_7129.x-min(_7129.w,_7129.y);
float _6538=_7129.x-(_6613*0.5);
float _6544=abs((2.0*_6538)-1.0);
vec4 _7130;
if (_3123.y<_3123.z)
{
_7130=vec4(_3123.zy,-1.0,0.666667);
}
else
{
_7130=vec4(_3123.yz,0.0,-0.333333);
}
vec4 _7131;
if (_3123.x<_7130.x)
{
_7131=vec4(_7130.xyw,_3123.x);
}
else
{
_7131=vec4(_3123.x,_7130.yzx);
}
float _6774=6.0*abs(((_7131.w-_7131.y)/((6.0*(_7131.x-min(_7131.w,_7131.y)))+1e-07))+_7131.z);
return ((clamp(vec3(abs(_6774-3.0)-1.0,2.0-abs(_6774-2.0),2.0-abs(_6774-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-_6544)*(_6613/(1.0-_6544))))+vec3(_6538);
}
#else
{
#if (BLEND_MODE_SATURATION)
{
vec3 _3131=a;
vec3 _3133=b;
vec4 _7124;
if (_3131.y<_3131.z)
{
_7124=vec4(_3131.zy,-1.0,0.666667);
}
else
{
_7124=vec4(_3131.yz,0.0,-0.333333);
}
vec4 _7125;
if (_3131.x<_7124.x)
{
_7125=vec4(_7124.xyw,_3131.x);
}
else
{
_7125=vec4(_3131.x,_7124.yzx);
}
float _6326=_7125.x-min(_7125.w,_7125.y);
float _6251=_7125.x-(_6326*0.5);
vec4 _7126;
if (_3133.y<_3133.z)
{
_7126=vec4(_3133.zy,-1.0,0.666667);
}
else
{
_7126=vec4(_3133.yz,0.0,-0.333333);
}
vec4 _7127;
if (_3133.x<_7126.x)
{
_7127=vec4(_7126.xy,_7422,_3133.x);
}
else
{
_7127=vec4(_3133.x,_7126.y,_7422,_7126.x);
}
float _6434=_7127.x-min(_7127.w,_7127.y);
float _6487=6.0*abs(((_7125.w-_7125.y)/((6.0*_6326)+1e-07))+_7125.z);
return ((clamp(vec3(abs(_6487-3.0)-1.0,2.0-abs(_6487-2.0),2.0-abs(_6487-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_6251)-1.0))*(_6434/(1.0-abs((2.0*(_7127.x-(_6434*0.5)))-1.0)))))+vec3(_6251);
}
#else
{
#if (BLEND_MODE_COLOR)
{
vec3 _3141=a;
vec3 _3143=b;
vec4 _7120;
if (_3143.y<_3143.z)
{
_7120=vec4(_3143.zy,-1.0,0.666667);
}
else
{
_7120=vec4(_3143.yz,0.0,-0.333333);
}
vec4 _7121;
if (_3143.x<_7120.x)
{
_7121=vec4(_7120.xyw,_3143.x);
}
else
{
_7121=vec4(_3143.x,_7120.yzx);
}
float _6039=_7121.x-min(_7121.w,_7121.y);
vec4 _7122;
if (_3141.y<_3141.z)
{
_7122=vec4(_3141.zy,-1.0,0.666667);
}
else
{
_7122=vec4(_3141.yz,0.0,-0.333333);
}
vec4 _7123;
if (_3141.x<_7122.x)
{
_7123=vec4(_7122.xy,_7422,_3141.x);
}
else
{
_7123=vec4(_3141.x,_7122.y,_7422,_7122.x);
}
float _6072=_7123.x-((_7123.x-min(_7123.w,_7123.y))*0.5);
float _6200=6.0*abs(((_7121.w-_7121.y)/((6.0*_6039)+1e-07))+_7121.z);
return ((clamp(vec3(abs(_6200-3.0)-1.0,2.0-abs(_6200-2.0),2.0-abs(_6200-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_6072)-1.0))*(_6039/(1.0-abs((2.0*(_7121.x-(_6039*0.5)))-1.0)))))+vec3(_6072);
}
#else
{
#if (BLEND_MODE_LUMINOSITY)
{
vec3 _3151=a;
vec3 _3153=b;
vec4 _7116;
if (_3151.y<_3151.z)
{
_7116=vec4(_3151.zy,-1.0,0.666667);
}
else
{
_7116=vec4(_3151.yz,0.0,-0.333333);
}
vec4 _7117;
if (_3151.x<_7116.x)
{
_7117=vec4(_7116.xyw,_3151.x);
}
else
{
_7117=vec4(_3151.x,_7116.yzx);
}
float _5752=_7117.x-min(_7117.w,_7117.y);
vec4 _7118;
if (_3153.y<_3153.z)
{
_7118=vec4(_3153.zy,-1.0,0.666667);
}
else
{
_7118=vec4(_3153.yz,0.0,-0.333333);
}
vec4 _7119;
if (_3153.x<_7118.x)
{
_7119=vec4(_7118.xy,_7422,_3153.x);
}
else
{
_7119=vec4(_3153.x,_7118.y,_7422,_7118.x);
}
float _5785=_7119.x-((_7119.x-min(_7119.w,_7119.y))*0.5);
float _5913=6.0*abs(((_7117.w-_7117.y)/((6.0*_5752)+1e-07))+_7117.z);
return ((clamp(vec3(abs(_5913-3.0)-1.0,2.0-abs(_5913-2.0),2.0-abs(_5913-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_5785)-1.0))*(_5752/(1.0-abs((2.0*(_7117.x-(_5752*0.5)))-1.0)))))+vec3(_5785);
}
#else
{
return vec3(0.0);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}

vec4 ngsPixelShader(inout vec4 result)
{
#if (sc_ProjectiveShadowsCaster)
{
vec4 param=result;
return evaluateShadowCasterColor(param);
}
#else
{
#if (sc_BlendMode_Custom)
{
vec3 _5066=getFramebufferColor().xyz;
vec3 _5061=_5066;
vec3 _5062=result.xyz;
vec3 _5079=mix(_5066,definedBlend(_5061,_5062).xyz,vec3(result.w));
vec4 _7031=vec4(_5079.x,_5079.y,_5079.z,_7364.w);
_7031.w=1.0;
result=_7031;
}
#else
{
#if (sc_BlendMode_MultiplyOriginal)
{
vec3 _3953=mix(vec3(1.0),result.xyz,vec3(result.w));
result=vec4(_3953.x,_3953.y,_3953.z,result.w);
}
#else
{
#if (sc_BlendMode_Screen)
{
vec3 _3963=result.xyz*result.w;
result=vec4(_3963.x,_3963.y,_3963.z,result.w);
}
#endif
}
#endif
}
#endif
return result;
}
#endif
}

float getFrontLayerZTestEpsilon()
{
#if (sc_SkinBonesCount>0)
{
return 5e-07;
}
#else
{
return 5e-08;
}
#endif
}

float getDepthOrderingEpsilon()
{
#if (sc_SkinBonesCount>0)
{
return 0.001;
}
#else
{
return 0.0;
}
#endif
}

float viewSpaceDepth()
{
#if (UseViewSpaceDepthVariant&&((sc_OITDepthGatherPass||sc_OITCompositingPass)||sc_OITDepthBoundsPass))
{
return varViewSpaceDepth;
}
#else
{
return sc_ProjectionMatrixArray[sc_GetStereoViewIndex()][3].z/(sc_ProjectionMatrixArray[sc_GetStereoViewIndex()][2].z+((gl_FragCoord.z*2.0)-1.0));
}
#endif
}

void oitCompositing(vec4 materialColor)
{
#if (sc_OITCompositingPass)
{
vec2 _3488=getScreenUV();
#if (sc_OITMaxLayers4Plus1)
{
if ((gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,_3488).x)<=getFrontLayerZTestEpsilon())
{
discard;
}
}
#endif
int depths[8];
int alphas[8];
for (int _7178=0; _7178<8; depths[_7178]=0,alphas[_7178]=0,_7178++)
{
}
int _7181;
#if (sc_OITMaxLayers8)
{
_7181=2;
}
#else
{
_7181=1;
}
#endif
vec4 _7192;
vec4 _7199;
vec4 _7256;
_7256=_7196;
_7199=_7196;
_7192=_7196;
vec4 _7190;
vec4 _7197;
vec4 _7254;
for (int _7179=0; _7179<_7181; _7256=_7254,_7199=_7197,_7192=_7190,_7179++)
{
vec4 _7191;
vec4 _7198;
vec4 _7255;
if (_7179==0)
{
_7255=texture2D(sc_OITAlpha0,_3488);
_7198=texture2D(sc_OITDepthLow0,_3488);
_7191=texture2D(sc_OITDepthHigh0,_3488);
}
else
{
_7255=_7256;
_7198=_7199;
_7191=_7192;
}
if (_7179==1)
{
_7254=texture2D(sc_OITAlpha1,_3488);
_7197=texture2D(sc_OITDepthLow1,_3488);
_7190=texture2D(sc_OITDepthHigh1,_3488);
}
else
{
_7254=_7255;
_7197=_7198;
_7190=_7191;
}
if (any(notEqual(_7190,vec4(0.0)))||any(notEqual(_7197,vec4(0.0))))
{
int param[8];
param[0]=depths[0];
param[1]=depths[1];
param[2]=depths[2];
param[3]=depths[3];
param[4]=depths[4];
param[5]=depths[5];
param[6]=depths[6];
param[7]=depths[7];
#if (sc_OITCompositingPass)
{
int _7204=((_7179+1)*4)-1;
float _7300=floor((_7190.w*255.0)+0.5);
for (; _7204>=(_7179*4); param[_7204]=(param[_7204]*4)+int(floor(mod(_7300,4.0))),_7300=floor(_7300*0.25),_7204--)
{
}
}
#endif
depths[0]=param[0];
depths[1]=param[1];
depths[2]=param[2];
depths[3]=param[3];
depths[4]=param[4];
depths[5]=param[5];
depths[6]=param[6];
depths[7]=param[7];
int param_1[8];
param_1[0]=param[0];
param_1[1]=param[1];
param_1[2]=param[2];
param_1[3]=param[3];
param_1[4]=param[4];
param_1[5]=param[5];
param_1[6]=param[6];
param_1[7]=param[7];
#if (sc_OITCompositingPass)
{
int _7209=((_7179+1)*4)-1;
float _7299=floor((_7190.z*255.0)+0.5);
for (; _7209>=(_7179*4); param_1[_7209]=(param_1[_7209]*4)+int(floor(mod(_7299,4.0))),_7299=floor(_7299*0.25),_7209--)
{
}
}
#endif
depths[0]=param_1[0];
depths[1]=param_1[1];
depths[2]=param_1[2];
depths[3]=param_1[3];
depths[4]=param_1[4];
depths[5]=param_1[5];
depths[6]=param_1[6];
depths[7]=param_1[7];
int param_2[8];
param_2[0]=param_1[0];
param_2[1]=param_1[1];
param_2[2]=param_1[2];
param_2[3]=param_1[3];
param_2[4]=param_1[4];
param_2[5]=param_1[5];
param_2[6]=param_1[6];
param_2[7]=param_1[7];
#if (sc_OITCompositingPass)
{
int _7214=((_7179+1)*4)-1;
float _7298=floor((_7190.y*255.0)+0.5);
for (; _7214>=(_7179*4); param_2[_7214]=(param_2[_7214]*4)+int(floor(mod(_7298,4.0))),_7298=floor(_7298*0.25),_7214--)
{
}
}
#endif
depths[0]=param_2[0];
depths[1]=param_2[1];
depths[2]=param_2[2];
depths[3]=param_2[3];
depths[4]=param_2[4];
depths[5]=param_2[5];
depths[6]=param_2[6];
depths[7]=param_2[7];
int param_3[8];
param_3[0]=param_2[0];
param_3[1]=param_2[1];
param_3[2]=param_2[2];
param_3[3]=param_2[3];
param_3[4]=param_2[4];
param_3[5]=param_2[5];
param_3[6]=param_2[6];
param_3[7]=param_2[7];
#if (sc_OITCompositingPass)
{
int _7219=((_7179+1)*4)-1;
float _7297=floor((_7190.x*255.0)+0.5);
for (; _7219>=(_7179*4); param_3[_7219]=(param_3[_7219]*4)+int(floor(mod(_7297,4.0))),_7297=floor(_7297*0.25),_7219--)
{
}
}
#endif
depths[0]=param_3[0];
depths[1]=param_3[1];
depths[2]=param_3[2];
depths[3]=param_3[3];
depths[4]=param_3[4];
depths[5]=param_3[5];
depths[6]=param_3[6];
depths[7]=param_3[7];
int param_4[8];
param_4[0]=param_3[0];
param_4[1]=param_3[1];
param_4[2]=param_3[2];
param_4[3]=param_3[3];
param_4[4]=param_3[4];
param_4[5]=param_3[5];
param_4[6]=param_3[6];
param_4[7]=param_3[7];
#if (sc_OITCompositingPass)
{
int _7230=((_7179+1)*4)-1;
float _7296=floor((_7197.w*255.0)+0.5);
for (; _7230>=(_7179*4); param_4[_7230]=(param_4[_7230]*4)+int(floor(mod(_7296,4.0))),_7296=floor(_7296*0.25),_7230--)
{
}
}
#endif
depths[0]=param_4[0];
depths[1]=param_4[1];
depths[2]=param_4[2];
depths[3]=param_4[3];
depths[4]=param_4[4];
depths[5]=param_4[5];
depths[6]=param_4[6];
depths[7]=param_4[7];
int param_5[8];
param_5[0]=param_4[0];
param_5[1]=param_4[1];
param_5[2]=param_4[2];
param_5[3]=param_4[3];
param_5[4]=param_4[4];
param_5[5]=param_4[5];
param_5[6]=param_4[6];
param_5[7]=param_4[7];
#if (sc_OITCompositingPass)
{
int _7235=((_7179+1)*4)-1;
float _7295=floor((_7197.z*255.0)+0.5);
for (; _7235>=(_7179*4); param_5[_7235]=(param_5[_7235]*4)+int(floor(mod(_7295,4.0))),_7295=floor(_7295*0.25),_7235--)
{
}
}
#endif
depths[0]=param_5[0];
depths[1]=param_5[1];
depths[2]=param_5[2];
depths[3]=param_5[3];
depths[4]=param_5[4];
depths[5]=param_5[5];
depths[6]=param_5[6];
depths[7]=param_5[7];
int param_6[8];
param_6[0]=param_5[0];
param_6[1]=param_5[1];
param_6[2]=param_5[2];
param_6[3]=param_5[3];
param_6[4]=param_5[4];
param_6[5]=param_5[5];
param_6[6]=param_5[6];
param_6[7]=param_5[7];
#if (sc_OITCompositingPass)
{
int _7240=((_7179+1)*4)-1;
float _7294=floor((_7197.y*255.0)+0.5);
for (; _7240>=(_7179*4); param_6[_7240]=(param_6[_7240]*4)+int(floor(mod(_7294,4.0))),_7294=floor(_7294*0.25),_7240--)
{
}
}
#endif
depths[0]=param_6[0];
depths[1]=param_6[1];
depths[2]=param_6[2];
depths[3]=param_6[3];
depths[4]=param_6[4];
depths[5]=param_6[5];
depths[6]=param_6[6];
depths[7]=param_6[7];
int param_7[8];
param_7[0]=param_6[0];
param_7[1]=param_6[1];
param_7[2]=param_6[2];
param_7[3]=param_6[3];
param_7[4]=param_6[4];
param_7[5]=param_6[5];
param_7[6]=param_6[6];
param_7[7]=param_6[7];
#if (sc_OITCompositingPass)
{
int _7245=((_7179+1)*4)-1;
float _7293=floor((_7197.x*255.0)+0.5);
for (; _7245>=(_7179*4); param_7[_7245]=(param_7[_7245]*4)+int(floor(mod(_7293,4.0))),_7293=floor(_7293*0.25),_7245--)
{
}
}
#endif
depths[0]=param_7[0];
depths[1]=param_7[1];
depths[2]=param_7[2];
depths[3]=param_7[3];
depths[4]=param_7[4];
depths[5]=param_7[5];
depths[6]=param_7[6];
depths[7]=param_7[7];
int param_8[8];
param_8[0]=alphas[0];
param_8[1]=alphas[1];
param_8[2]=alphas[2];
param_8[3]=alphas[3];
param_8[4]=alphas[4];
param_8[5]=alphas[5];
param_8[6]=alphas[6];
param_8[7]=alphas[7];
#if (sc_OITCompositingPass)
{
int _7270=((_7179+1)*4)-1;
float _7292=floor((_7254.w*255.0)+0.5);
for (; _7270>=(_7179*4); param_8[_7270]=(param_8[_7270]*4)+int(floor(mod(_7292,4.0))),_7292=floor(_7292*0.25),_7270--)
{
}
}
#endif
alphas[0]=param_8[0];
alphas[1]=param_8[1];
alphas[2]=param_8[2];
alphas[3]=param_8[3];
alphas[4]=param_8[4];
alphas[5]=param_8[5];
alphas[6]=param_8[6];
alphas[7]=param_8[7];
int param_9[8];
param_9[0]=param_8[0];
param_9[1]=param_8[1];
param_9[2]=param_8[2];
param_9[3]=param_8[3];
param_9[4]=param_8[4];
param_9[5]=param_8[5];
param_9[6]=param_8[6];
param_9[7]=param_8[7];
#if (sc_OITCompositingPass)
{
int _7275=((_7179+1)*4)-1;
float _7291=floor((_7254.z*255.0)+0.5);
for (; _7275>=(_7179*4); param_9[_7275]=(param_9[_7275]*4)+int(floor(mod(_7291,4.0))),_7291=floor(_7291*0.25),_7275--)
{
}
}
#endif
alphas[0]=param_9[0];
alphas[1]=param_9[1];
alphas[2]=param_9[2];
alphas[3]=param_9[3];
alphas[4]=param_9[4];
alphas[5]=param_9[5];
alphas[6]=param_9[6];
alphas[7]=param_9[7];
int param_10[8];
param_10[0]=param_9[0];
param_10[1]=param_9[1];
param_10[2]=param_9[2];
param_10[3]=param_9[3];
param_10[4]=param_9[4];
param_10[5]=param_9[5];
param_10[6]=param_9[6];
param_10[7]=param_9[7];
#if (sc_OITCompositingPass)
{
int _7280=((_7179+1)*4)-1;
float _7290=floor((_7254.y*255.0)+0.5);
for (; _7280>=(_7179*4); param_10[_7280]=(param_10[_7280]*4)+int(floor(mod(_7290,4.0))),_7290=floor(_7290*0.25),_7280--)
{
}
}
#endif
alphas[0]=param_10[0];
alphas[1]=param_10[1];
alphas[2]=param_10[2];
alphas[3]=param_10[3];
alphas[4]=param_10[4];
alphas[5]=param_10[5];
alphas[6]=param_10[6];
alphas[7]=param_10[7];
int param_11[8];
param_11[0]=param_10[0];
param_11[1]=param_10[1];
param_11[2]=param_10[2];
param_11[3]=param_10[3];
param_11[4]=param_10[4];
param_11[5]=param_10[5];
param_11[6]=param_10[6];
param_11[7]=param_10[7];
#if (sc_OITCompositingPass)
{
int _7285=((_7179+1)*4)-1;
float _7289=floor((_7254.x*255.0)+0.5);
for (; _7285>=(_7179*4); param_11[_7285]=(param_11[_7285]*4)+int(floor(mod(_7289,4.0))),_7289=floor(_7289*0.25),_7285--)
{
}
}
#endif
alphas[0]=param_11[0];
alphas[1]=param_11[1];
alphas[2]=param_11[2];
alphas[3]=param_11[3];
alphas[4]=param_11[4];
alphas[5]=param_11[5];
alphas[6]=param_11[6];
alphas[7]=param_11[7];
}
continue;
}
mediump vec4 _5536=texture2D(sc_OITFilteredDepthBoundsTexture,_3488);
int _7185;
#if (sc_SkinBonesCount>0)
{
float _5546=(1.0-_5536.x)*1000.0;
_7185=int(clamp(((_5546+getDepthOrderingEpsilon())-_5546)/((_5536.y*1000.0)-_5546),0.0,1.0)*65535.0);
}
#else
{
_7185=0;
}
#endif
float _5583=(1.0-_5536.x)*1000.0;
vec4 _7183;
_7183=materialColor*materialColor.w;
vec4 _7328;
for (int _7182=0; _7182<8; _7183=_7328,_7182++)
{
int _3725=depths[_7182];
int _3728=int(clamp((viewSpaceDepth()-_5583)/((_5536.y*1000.0)-_5583),0.0,1.0)*65535.0)-_7185;
bool _3729=_3725<_3728;
bool _3736;
if (_3729)
{
_3736=depths[_7182]>0;
}
else
{
_3736=_3729;
}
if (_3736)
{
vec3 _3747=_7183.xyz*(1.0-(float(alphas[_7182])*0.00392157));
_7328=vec4(_3747.x,_3747.y,_3747.z,_7183.w);
}
else
{
_7328=_7183;
}
continue;
}
vec4 param_12=_7183;
sc_writeFragData0(param_12);
#if (sc_OITMaxLayersVisualizeLayerCount)
{
discard;
}
#endif
}
#endif
}

float packValue(inout int value)
{
#if (sc_OITDepthGatherPass)
{
int _3302=value;
value/=4;
return floor(floor(mod(float(_3302),4.0))*64.0)*0.00392157;
}
#else
{
return 0.0;
}
#endif
}

void oitDepthGather(vec4 materialColor)
{
#if (sc_OITDepthGatherPass)
{
vec2 _3358=getScreenUV();
#if (sc_OITMaxLayers4Plus1)
{
if ((gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,_3358).x)<=getFrontLayerZTestEpsilon())
{
discard;
}
}
#endif
mediump vec4 _5606=texture2D(sc_OITFilteredDepthBoundsTexture,_3358);
float _5616=(1.0-_5606.x)*1000.0;
int param=int(clamp((viewSpaceDepth()-_5616)/((_5606.y*1000.0)-_5616),0.0,1.0)*65535.0);
float _3396=packValue(param);
vec4 _6987=_7175;
_6987.x=_3396;
int param_1=param;
float _3401=packValue(param_1);
vec4 _6989=_6987;
_6989.y=_3401;
int param_2=param_1;
float _3406=packValue(param_2);
vec4 _6991=_6989;
_6991.z=_3406;
int param_3=param_2;
float _3411=packValue(param_3);
vec4 _6993=_6991;
_6993.w=_3411;
int param_4=param_3;
float _3417=packValue(param_4);
vec4 _6995=_7175;
_6995.x=_3417;
int param_5=param_4;
float _3422=packValue(param_5);
vec4 _6997=_6995;
_6997.y=_3422;
int param_6=param_5;
float _3427=packValue(param_6);
vec4 _6999=_6997;
_6999.z=_3427;
int param_7=param_6;
float _3432=packValue(param_7);
vec4 _7001=_6999;
_7001.w=_3432;
int param_8=int(materialColor.w*255.0);
float _3438=packValue(param_8);
vec4 _7003=_7175;
_7003.x=_3438;
int param_9=param_8;
float _3443=packValue(param_9);
vec4 _7005=_7003;
_7005.y=_3443;
int param_10=param_9;
float _3448=packValue(param_10);
vec4 _7007=_7005;
_7007.z=_3448;
int param_11=param_10;
float _3453=packValue(param_11);
vec4 _7009=_7007;
_7009.w=_3453;
vec4 param_12=_7001;
sc_writeFragData0(param_12);
vec4 param_13=_6993;
sc_writeFragData1(param_13);
vec4 param_14=_7009;
sc_writeFragData2(param_14);
#if (sc_OITMaxLayersVisualizeLayerCount)
{
vec4 param_15=vec4(0.00392157,0.0,0.0,0.0);
sc_writeFragData2(param_15);
}
#endif
}
#endif
}

void main()
{
float _7092;
if (overrideTimeEnable)
{
_7092=overrideTimeElapsed;
}
else
{
_7092=sc_Time.x;
}
float _7093;
if (overrideTimeEnable)
{
_7093=overrideTimeDelta;
}
else
{
_7093=sc_Time.y;
}
ssGlobals _6803=ssGlobals(_7092,_7093,_7096,varPackedTex.xy);
vec4 _7097;
#if (Tweak_N11)
{
ssGlobals _4912=_6803;
vec4 _4911;
Node19_Texture_2D_Parameter(_4911,_4912);
_7097=_4911*baseColor;
}
#else
{
_7097=baseColor;
}
#endif
ssGlobals param_1=_6803;
vec4 param;
Node2_Texture_2D_Parameter(param,param_1);
vec4 _4758=param;
vec4 _6811=vec4(_7097.x,_7097.y,_7097.z,vec4(0.0).w);
_6811.w=_4758.x;
#if (sc_BlendMode_AlphaTest)
{
if (_4758.x<alphaTestThreshold)
{
discard;
}
}
#endif
#if (ENABLE_STIPPLE_PATTERN_TEST)
{
if (_4758.x<((mod(dot(floor(mod(gl_FragCoord.xy,vec2(4.0))),vec2(4.0,1.0))*9.0,16.0)+1.0)*0.0588235))
{
discard;
}
}
#endif
vec4 param_2=_6811;
vec4 _4776=ngsPixelShader(param_2);
vec4 _4779=max(_4776,vec4(0.0));
vec4 param_3=_4779;
sc_writeFragData0(param_3);
vec4 _4968=clamp(_4779,vec4(0.0),vec4(1.0));
#if (sc_OITDepthBoundsPass)
{
#if (sc_OITDepthBoundsPass)
{
float _5028=clamp(viewSpaceDepth()*0.001,0.0,1.0);
vec4 _5023=vec4(max(0.0,1.00392-_5028),min(1.0,_5028+0.00392157),0.0,0.0);
sc_writeFragData0(_5023);
}
#endif
}
#else
{
#if (sc_OITDepthPrepass)
{
vec4 _5018=vec4(1.0);
sc_writeFragData0(_5018);
}
#else
{
#if (sc_OITDepthGatherPass)
{
vec4 _4960=_4968;
oitDepthGather(_4960);
}
#else
{
#if (sc_OITCompositingPass)
{
vec4 _4961=_4968;
oitCompositing(_4961);
}
#else
{
#if (sc_OITFrontLayerPass)
{
#if (sc_OITFrontLayerPass)
{
if (abs(gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,getScreenUV()).x)>getFrontLayerZTestEpsilon())
{
discard;
}
vec4 _4996=_4968;
sc_writeFragData0(_4996);
}
#endif
}
#else
{
vec4 _4963=_4968;
sc_writeFragData0(_4963);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
