#version 100 sc_convert_to 300 es
#if defined VERTEX_SHADER
#define SC_REMOVE_ENVMAP_FROM_AMBIENT_LIGHT_STRUCT
#define SC_DISABLE_FRUSTUM_CULLING



#include <std2.glsl>
#include <std2_vs.glsl>
#include <std2_fs.glsl>
#include <std2_texture.glsl>


uniform mat4 uv2Matrix;
uniform mat4 realModelMatrix;

varying vec4 varColor;
attribute vec4 color;
varying vec4 Interpolator0;

vec4 _3001;
mat3 _3003;
vec2 _3016;
vec3 _3027;

void ngsVertexShaderEnd(sc_Vertex_t v,vec3 WorldPosition,vec3 WorldNormal,vec3 WorldTangent,vec4 ScreenPosition)
{
varPos=WorldPosition;
varNormal=normalize(WorldNormal);
vec3 _2040=normalize(WorldTangent);
varTangent=vec4(_2040.x,_2040.y,_2040.z,varTangent.w);
varTangent.w=tangent.w;
#if (UseViewSpaceDepthVariant&&((sc_OITDepthGatherPass||sc_OITCompositingPass)||sc_OITDepthBoundsPass))
{
vec4 param=v.position;
varViewSpaceDepth=-sc_ObjectToView(param).z;
}
#endif
vec4 _3039;
#if (sc_RenderingSpace==3)
{
_3039=ScreenPosition;
}
#else
{
vec4 _3040;
#if (sc_RenderingSpace==4)
{
_3040=(sc_ModelViewMatrixArray[sc_GetStereoViewIndex()]*v.position)*vec4(1.0/sc_Camera.aspect,1.0,1.0,1.0);
}
#else
{
vec4 _3041;
#if (sc_RenderingSpace==2)
{
_3041=sc_ViewProjectionMatrixArray[sc_GetStereoViewIndex()]*vec4(varPos,1.0);
}
#else
{
vec4 _3042;
#if (sc_RenderingSpace==1)
{
_3042=sc_ViewProjectionMatrixArray[sc_GetStereoViewIndex()]*vec4(varPos,1.0);
}
#else
{
_3042=vec4(0.0);
}
#endif
_3041=_3042;
}
#endif
_3040=_3041;
}
#endif
_3039=_3040;
}
#endif
varPackedTex=vec4(v.texture0,v.texture1);
#if (sc_ProjectiveShadowsReceiver)
{
vec4 param_1=v.position;
varShadowTex=getProjectedTexCoords(param_1);
}
#endif
vec4 _3043;
#if (sc_DepthBufferMode==1)
{
vec4 _2951=_3039;
_2951.z=((log2(max(sc_Camera.clipPlanes.x,1.0+_3039.w))*(2.0/log2(sc_Camera.clipPlanes.y+1.0)))-1.0)*_3039.w;
_3043=_2951;
}
#else
{
_3043=_3039;
}
#endif
gl_Position=_3043;
}

void main()
{
sc_Vertex_t _2673=sc_LoadVertexAttributes();
sc_BlendVertex(_2673);
sc_Vertex_t _2674=_2673;
sc_SkinVertex(_2674);
sc_Vertex_t _2682=_2674;
#if (sc_RenderingSpace==3)
{
varPos=vec3(0.0);
varNormal=_2682.normal;
varTangent=vec4(_2682.tangent.x,_2682.tangent.y,_2682.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==4)
{
varPos=vec3(0.0);
varNormal=_2682.normal;
varTangent=vec4(_2682.tangent.x,_2682.tangent.y,_2682.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==2)
{
varPos=_2682.position.xyz;
varNormal=_2682.normal;
varTangent=vec4(_2682.tangent.x,_2682.tangent.y,_2682.tangent.z,varTangent.w);
}
#else
{
#if (sc_RenderingSpace==1)
{
varPos=(sc_ModelMatrix*_2682.position).xyz;
varNormal=sc_NormalMatrix*_2682.normal;
vec3 _2699=sc_NormalMatrix*_2682.tangent;
varTangent=vec4(_2699.x,_2699.y,_2699.z,varTangent.w);
}
#endif
}
#endif
}
#endif
}
#endif
varColor=color;
vec3 _2460=normalize((sc_ModelMatrixInverse*vec4(varNormal,0.0)).xyz);
vec4 _2468=sc_ModelMatrixInverse*vec4(varPos,1.0);
vec4 _2742=sc_ViewProjectionMatrixInverseArray[sc_GetStereoViewIndex()]*vec4((_2682.texture0*2.0)+vec2(-1.0),0.0,1.0);
vec4 _2920=vec4(_2460.x,_2460.y,_2460.z,vec4(0.0).w);
_2920.w=0.0;
vec4 _2516=realModelMatrix*_2920;
float _2755=dot(_2516,_2516);
float _2976;
if (_2755>0.0)
{
_2976=1.0/sqrt(_2755);
}
else
{
_2976=0.0;
}
vec4 _2779=sc_ViewProjectionMatrixInverseArray[sc_GetStereoViewIndex()]*vec4((_2516*_2976).xyz,1.0);
sc_Vertex_t param=_2682;
vec3 param_1=_2742.xyz/vec3(_2742.w);
vec3 param_2=_2779.xyz/vec3(_2779.w);
vec3 param_3=varTangent.xyz;
vec4 param_4=_2682.position;
ngsVertexShaderEnd(param,param_1,param_2,param_3,param_4);
vec4 _2923=vec4(_2468.x,_2468.y,_2468.z,vec4(0.0).w);
_2923.w=1.0;
vec4 _2811=uv2Matrix*(realModelMatrix*_2923);
vec2 _2828=(((vec2(_2811.xy)/vec2(_2811.w))-vec2(-1.0))*vec2(0.5))*1.0;
Interpolator0.x=_2828.x;
Interpolator0.y=_2828.y;
}

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#define SC_REMOVE_ENVMAP_FROM_AMBIENT_LIGHT_STRUCT
#define SC_DISABLE_FRUSTUM_CULLING



#include <std2.glsl>
#include <std2_vs.glsl>
#include <std2_fs.glsl>
#include <std2_texture.glsl>

struct ssGlobals
{
float gTimeElapsed;
float gTimeDelta;
float gTimeElapsedShifted;
};

#ifndef BLEND_MODE_LIGHTEN
#define BLEND_MODE_LIGHTEN 0
#elif BLEND_MODE_LIGHTEN==1
#undef BLEND_MODE_LIGHTEN
#define BLEND_MODE_LIGHTEN 1
#endif
#ifndef BLEND_MODE_DARKEN
#define BLEND_MODE_DARKEN 0
#elif BLEND_MODE_DARKEN==1
#undef BLEND_MODE_DARKEN
#define BLEND_MODE_DARKEN 1
#endif
#ifndef BLEND_MODE_DIVIDE
#define BLEND_MODE_DIVIDE 0
#elif BLEND_MODE_DIVIDE==1
#undef BLEND_MODE_DIVIDE
#define BLEND_MODE_DIVIDE 1
#endif
#ifndef BLEND_MODE_AVERAGE
#define BLEND_MODE_AVERAGE 0
#elif BLEND_MODE_AVERAGE==1
#undef BLEND_MODE_AVERAGE
#define BLEND_MODE_AVERAGE 1
#endif
#ifndef BLEND_MODE_SUBTRACT
#define BLEND_MODE_SUBTRACT 0
#elif BLEND_MODE_SUBTRACT==1
#undef BLEND_MODE_SUBTRACT
#define BLEND_MODE_SUBTRACT 1
#endif
#ifndef BLEND_MODE_DIFFERENCE
#define BLEND_MODE_DIFFERENCE 0
#elif BLEND_MODE_DIFFERENCE==1
#undef BLEND_MODE_DIFFERENCE
#define BLEND_MODE_DIFFERENCE 1
#endif
#ifndef BLEND_MODE_NEGATION
#define BLEND_MODE_NEGATION 0
#elif BLEND_MODE_NEGATION==1
#undef BLEND_MODE_NEGATION
#define BLEND_MODE_NEGATION 1
#endif
#ifndef BLEND_MODE_EXCLUSION
#define BLEND_MODE_EXCLUSION 0
#elif BLEND_MODE_EXCLUSION==1
#undef BLEND_MODE_EXCLUSION
#define BLEND_MODE_EXCLUSION 1
#endif
#ifndef BLEND_MODE_OVERLAY
#define BLEND_MODE_OVERLAY 0
#elif BLEND_MODE_OVERLAY==1
#undef BLEND_MODE_OVERLAY
#define BLEND_MODE_OVERLAY 1
#endif
#ifndef BLEND_MODE_SOFT_LIGHT
#define BLEND_MODE_SOFT_LIGHT 0
#elif BLEND_MODE_SOFT_LIGHT==1
#undef BLEND_MODE_SOFT_LIGHT
#define BLEND_MODE_SOFT_LIGHT 1
#endif
#ifndef BLEND_MODE_HARD_LIGHT
#define BLEND_MODE_HARD_LIGHT 0
#elif BLEND_MODE_HARD_LIGHT==1
#undef BLEND_MODE_HARD_LIGHT
#define BLEND_MODE_HARD_LIGHT 1
#endif
#ifndef BLEND_MODE_COLOR_DODGE
#define BLEND_MODE_COLOR_DODGE 0
#elif BLEND_MODE_COLOR_DODGE==1
#undef BLEND_MODE_COLOR_DODGE
#define BLEND_MODE_COLOR_DODGE 1
#endif
#ifndef BLEND_MODE_COLOR_BURN
#define BLEND_MODE_COLOR_BURN 0
#elif BLEND_MODE_COLOR_BURN==1
#undef BLEND_MODE_COLOR_BURN
#define BLEND_MODE_COLOR_BURN 1
#endif
#ifndef BLEND_MODE_LINEAR_LIGHT
#define BLEND_MODE_LINEAR_LIGHT 0
#elif BLEND_MODE_LINEAR_LIGHT==1
#undef BLEND_MODE_LINEAR_LIGHT
#define BLEND_MODE_LINEAR_LIGHT 1
#endif
#ifndef BLEND_MODE_VIVID_LIGHT
#define BLEND_MODE_VIVID_LIGHT 0
#elif BLEND_MODE_VIVID_LIGHT==1
#undef BLEND_MODE_VIVID_LIGHT
#define BLEND_MODE_VIVID_LIGHT 1
#endif
#ifndef BLEND_MODE_PIN_LIGHT
#define BLEND_MODE_PIN_LIGHT 0
#elif BLEND_MODE_PIN_LIGHT==1
#undef BLEND_MODE_PIN_LIGHT
#define BLEND_MODE_PIN_LIGHT 1
#endif
#ifndef BLEND_MODE_HARD_MIX
#define BLEND_MODE_HARD_MIX 0
#elif BLEND_MODE_HARD_MIX==1
#undef BLEND_MODE_HARD_MIX
#define BLEND_MODE_HARD_MIX 1
#endif
#ifndef BLEND_MODE_HARD_REFLECT
#define BLEND_MODE_HARD_REFLECT 0
#elif BLEND_MODE_HARD_REFLECT==1
#undef BLEND_MODE_HARD_REFLECT
#define BLEND_MODE_HARD_REFLECT 1
#endif
#ifndef BLEND_MODE_HARD_GLOW
#define BLEND_MODE_HARD_GLOW 0
#elif BLEND_MODE_HARD_GLOW==1
#undef BLEND_MODE_HARD_GLOW
#define BLEND_MODE_HARD_GLOW 1
#endif
#ifndef BLEND_MODE_HARD_PHOENIX
#define BLEND_MODE_HARD_PHOENIX 0
#elif BLEND_MODE_HARD_PHOENIX==1
#undef BLEND_MODE_HARD_PHOENIX
#define BLEND_MODE_HARD_PHOENIX 1
#endif
#ifndef BLEND_MODE_HUE
#define BLEND_MODE_HUE 0
#elif BLEND_MODE_HUE==1
#undef BLEND_MODE_HUE
#define BLEND_MODE_HUE 1
#endif
#ifndef BLEND_MODE_SATURATION
#define BLEND_MODE_SATURATION 0
#elif BLEND_MODE_SATURATION==1
#undef BLEND_MODE_SATURATION
#define BLEND_MODE_SATURATION 1
#endif
#ifndef BLEND_MODE_COLOR
#define BLEND_MODE_COLOR 0
#elif BLEND_MODE_COLOR==1
#undef BLEND_MODE_COLOR
#define BLEND_MODE_COLOR 1
#endif
#ifndef BLEND_MODE_LUMINOSITY
#define BLEND_MODE_LUMINOSITY 0
#elif BLEND_MODE_LUMINOSITY==1
#undef BLEND_MODE_LUMINOSITY
#define BLEND_MODE_LUMINOSITY 1
#endif
#ifndef baseTexHasSwappedViews
#define baseTexHasSwappedViews 0
#elif baseTexHasSwappedViews==1
#undef baseTexHasSwappedViews
#define baseTexHasSwappedViews 1
#endif
#ifndef baseTexLayout
#define baseTexLayout 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_baseTex
#define SC_SOFTWARE_WRAP_MODE_U_baseTex -1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 0
#elif SC_USE_CLAMP_TO_BORDER_baseTex==1
#undef SC_USE_CLAMP_TO_BORDER_baseTex
#define SC_USE_CLAMP_TO_BORDER_baseTex 1
#endif
#ifndef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 0
#elif SC_USE_UV_MIN_MAX_baseTex==1
#undef SC_USE_UV_MIN_MAX_baseTex
#define SC_USE_UV_MIN_MAX_baseTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_baseTex
#define SC_SOFTWARE_WRAP_MODE_V_baseTex -1
#endif
#ifndef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 0
#elif SC_USE_UV_TRANSFORM_baseTex==1
#undef SC_USE_UV_TRANSFORM_baseTex
#define SC_USE_UV_TRANSFORM_baseTex 1
#endif

uniform mediump sampler2D sc_OITFilteredDepthBoundsTexture;
uniform highp sampler2D sc_OITFrontDepthTexture;
uniform mediump sampler2D sc_OITDepthHigh0;
uniform mediump sampler2D sc_OITDepthLow0;
uniform mediump sampler2D sc_OITAlpha0;
uniform mediump sampler2D sc_OITDepthHigh1;
uniform mediump sampler2D sc_OITDepthLow1;
uniform mediump sampler2D sc_OITAlpha1;
uniform float alphaTestThreshold;
uniform vec4 baseTexDims;
uniform mediump sampler2DArray baseTexArrSC;
uniform mediump sampler2D baseTex;
uniform vec4 baseTexUvMinMax;
uniform mat3 baseTexTransform;
uniform vec4 baseTexBorderColor;
uniform bool overrideTimeEnable;
uniform float overrideTimeElapsed;
uniform float overrideTimeDelta;

varying vec4 Interpolator0;
varying vec4 varColor;

vec2 _6596;
float _6599;
vec4 _6676;
vec4 _6697;
vec4 _6865;
float _6898;

int baseTexGetStereoViewIndex()
{
#if (baseTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex();
}
#else
{
return sc_GetStereoViewIndex();
}
#endif
}

vec4 baseTexSampleViewIndexBias(vec2 uv,int viewIndex,float bias)
{
#if (baseTexLayout==2)
{
vec2 param=baseTexDims.xy;
vec2 param_1=uv;
int param_2=baseTexLayout;
int param_3=viewIndex;
float param_4=bias;
return sc_SampleView(baseTexArrSC,param,param_1,param_2,param_3,param_4);
}
#else
{
vec2 param_5=baseTexDims.xy;
vec2 param_6=uv;
int param_7=baseTexLayout;
int param_8=viewIndex;
float param_9=bias;
return sc_SampleView(baseTex,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

void Node2_Texture_2D_Parameter(vec2 UVCoord,out vec4 Output,ssGlobals Globals)
{
vec2 _4093=UVCoord;
vec2 _6867;
float _6870;
#if ((SC_SOFTWARE_WRAP_MODE_U_baseTex==0)||(SC_SOFTWARE_WRAP_MODE_U_baseTex==3))
{
float _4104=clamp(_4093.x,0.0,1.0);
float _6873;
#if (SC_USE_CLAMP_TO_BORDER_baseTex&&(!SC_USE_UV_MIN_MAX_baseTex))
{
_6873=step(abs(_4093.x-_4104),1e-05);
}
#else
{
_6873=1.0;
}
#endif
vec2 _6572=_4093;
_6572.x=_4104;
_6870=_6873;
_6867=_6572;
}
#else
{
vec2 _6868;
#if (SC_SOFTWARE_WRAP_MODE_U_baseTex==1)
{
vec2 _6568=_4093;
_6568.x=fract(_4093.x);
_6868=_6568;
}
#else
{
vec2 _6869;
#if (SC_SOFTWARE_WRAP_MODE_U_baseTex==2)
{
float _4137=fract(_4093.x);
vec2 _6565=_4093;
_6565.x=mix(_4137,1.0-_4137,clamp(step(0.25,fract((_4093.x-_4137)*0.5)),0.0,1.0));
_6869=_6565;
}
#else
{
_6869=_4093;
}
#endif
_6868=_6869;
}
#endif
_6870=1.0;
_6867=_6868;
}
#endif
vec2 _6875;
float _6878;
#if ((SC_SOFTWARE_WRAP_MODE_V_baseTex==0)||(SC_SOFTWARE_WRAP_MODE_V_baseTex==3))
{
float _4165=clamp(_6867.y,0.0,1.0);
float _6881;
#if (SC_USE_CLAMP_TO_BORDER_baseTex&&(!SC_USE_UV_MIN_MAX_baseTex))
{
_6881=_6870*step(abs(_6867.y-_4165),1e-05);
}
#else
{
_6881=_6870;
}
#endif
vec2 _6583=_6867;
_6583.y=_4165;
_6878=_6881;
_6875=_6583;
}
#else
{
vec2 _6876;
#if (SC_SOFTWARE_WRAP_MODE_V_baseTex==1)
{
vec2 _6579=_6867;
_6579.y=fract(_6867.y);
_6876=_6579;
}
#else
{
vec2 _6877;
#if (SC_SOFTWARE_WRAP_MODE_V_baseTex==2)
{
float _4195=fract(_6867.y);
vec2 _6576=_6867;
_6576.y=mix(_4195,1.0-_4195,clamp(step(0.25,fract((_6867.y-_4195)*0.5)),0.0,1.0));
_6877=_6576;
}
#else
{
_6877=_6867;
}
#endif
_6876=_6877;
}
#endif
_6878=_6870;
_6875=_6876;
}
#endif
vec2 _6885;
float _6888;
#if (SC_USE_UV_MIN_MAX_baseTex)
{
float _4223=clamp(_6875.x,baseTexUvMinMax.x,baseTexUvMinMax.z);
float _6883;
#if (SC_USE_CLAMP_TO_BORDER_baseTex)
{
_6883=_6878*step(abs(_6875.x-_4223),1e-05);
}
#else
{
_6883=_6878;
}
#endif
vec2 _6587=_6875;
_6587.x=_4223;
float _4243=clamp(_6875.y,baseTexUvMinMax.y,baseTexUvMinMax.w);
float _6889;
#if (SC_USE_CLAMP_TO_BORDER_baseTex)
{
_6889=_6883*step(abs(_6875.y-_4243),1e-05);
}
#else
{
_6889=_6883;
}
#endif
vec2 _6591=_6587;
_6591.y=_4243;
_6888=_6889;
_6885=_6591;
}
#else
{
_6888=_6878;
_6885=_6875;
}
#endif
vec2 _6886;
#if (SC_USE_UV_TRANSFORM_baseTex)
{
_6886=vec2((baseTexTransform*vec3(_6885,1.0)).xy);
}
#else
{
_6886=_6885;
}
#endif
vec2 param=_6886;
vec2 _4592=quantizeUV(param);
int _4593=baseTexGetStereoViewIndex();
float _4594=0.0;
vec4 _4600=baseTexSampleViewIndexBias(_4592,_4593,_4594);
vec4 _6890;
#if (SC_USE_CLAMP_TO_BORDER_baseTex)
{
_6890=mix(baseTexBorderColor,_4600,vec4(_6888));
}
#else
{
_6890=_4600;
}
#endif
Output=_6890;
}

vec3 definedBlend(vec3 a,vec3 b)
{
#if (BLEND_MODE_LIGHTEN)
{
return max(a,b);
}
#else
{
#if (BLEND_MODE_DARKEN)
{
return min(a,b);
}
#else
{
#if (BLEND_MODE_DIVIDE)
{
return b/a;
}
#else
{
#if (BLEND_MODE_AVERAGE)
{
return (a+b)*0.5;
}
#else
{
#if (BLEND_MODE_SUBTRACT)
{
return max((a+b)-vec3(1.0),vec3(0.0));
}
#else
{
#if (BLEND_MODE_DIFFERENCE)
{
return abs(a-b);
}
#else
{
#if (BLEND_MODE_NEGATION)
{
return vec3(1.0)-abs((vec3(1.0)-a)-b);
}
#else
{
#if (BLEND_MODE_EXCLUSION)
{
return (a+b)-((a*2.0)*b);
}
#else
{
#if (BLEND_MODE_OVERLAY)
{
float _6672;
if (a.x<0.5)
{
_6672=(2.0*a.x)*b.x;
}
else
{
_6672=1.0-((2.0*(1.0-a.x))*(1.0-b.x));
}
float _6673;
if (a.y<0.5)
{
_6673=(2.0*a.y)*b.y;
}
else
{
_6673=1.0-((2.0*(1.0-a.y))*(1.0-b.y));
}
float _6674;
if (a.z<0.5)
{
_6674=(2.0*a.z)*b.z;
}
else
{
_6674=1.0-((2.0*(1.0-a.z))*(1.0-b.z));
}
return vec3(_6672,_6673,_6674);
}
#else
{
#if (BLEND_MODE_SOFT_LIGHT)
{
return (((vec3(1.0)-(b*2.0))*a)*a)+((a*2.0)*b);
}
#else
{
#if (BLEND_MODE_HARD_LIGHT)
{
float _6669;
if (b.x<0.5)
{
_6669=(2.0*b.x)*a.x;
}
else
{
_6669=1.0-((2.0*(1.0-b.x))*(1.0-a.x));
}
float _6670;
if (b.y<0.5)
{
_6670=(2.0*b.y)*a.y;
}
else
{
_6670=1.0-((2.0*(1.0-b.y))*(1.0-a.y));
}
float _6671;
if (b.z<0.5)
{
_6671=(2.0*b.z)*a.z;
}
else
{
_6671=1.0-((2.0*(1.0-b.z))*(1.0-a.z));
}
return vec3(_6669,_6670,_6671);
}
#else
{
#if (BLEND_MODE_COLOR_DODGE)
{
float _6666;
if (b.x==1.0)
{
_6666=b.x;
}
else
{
_6666=min(a.x/(1.0-b.x),1.0);
}
float _6667;
if (b.y==1.0)
{
_6667=b.y;
}
else
{
_6667=min(a.y/(1.0-b.y),1.0);
}
float _6668;
if (b.z==1.0)
{
_6668=b.z;
}
else
{
_6668=min(a.z/(1.0-b.z),1.0);
}
return vec3(_6666,_6667,_6668);
}
#else
{
#if (BLEND_MODE_COLOR_BURN)
{
float _6663;
if (b.x==0.0)
{
_6663=b.x;
}
else
{
_6663=max(1.0-((1.0-a.x)/b.x),0.0);
}
float _6664;
if (b.y==0.0)
{
_6664=b.y;
}
else
{
_6664=max(1.0-((1.0-a.y)/b.y),0.0);
}
float _6665;
if (b.z==0.0)
{
_6665=b.z;
}
else
{
_6665=max(1.0-((1.0-a.z)/b.z),0.0);
}
return vec3(_6663,_6664,_6665);
}
#else
{
#if (BLEND_MODE_LINEAR_LIGHT)
{
float _6660;
if (b.x<0.5)
{
_6660=max((a.x+(2.0*b.x))-1.0,0.0);
}
else
{
_6660=min(a.x+(2.0*(b.x-0.5)),1.0);
}
float _6661;
if (b.y<0.5)
{
_6661=max((a.y+(2.0*b.y))-1.0,0.0);
}
else
{
_6661=min(a.y+(2.0*(b.y-0.5)),1.0);
}
float _6662;
if (b.z<0.5)
{
_6662=max((a.z+(2.0*b.z))-1.0,0.0);
}
else
{
_6662=min(a.z+(2.0*(b.z-0.5)),1.0);
}
return vec3(_6660,_6661,_6662);
}
#else
{
#if (BLEND_MODE_VIVID_LIGHT)
{
float _6653;
if (b.x<0.5)
{
float _6652;
if ((2.0*b.x)==0.0)
{
_6652=2.0*b.x;
}
else
{
_6652=max(1.0-((1.0-a.x)/(2.0*b.x)),0.0);
}
_6653=_6652;
}
else
{
float _6651;
if ((2.0*(b.x-0.5))==1.0)
{
_6651=2.0*(b.x-0.5);
}
else
{
_6651=min(a.x/(1.0-(2.0*(b.x-0.5))),1.0);
}
_6653=_6651;
}
float _6656;
if (b.y<0.5)
{
float _6655;
if ((2.0*b.y)==0.0)
{
_6655=2.0*b.y;
}
else
{
_6655=max(1.0-((1.0-a.y)/(2.0*b.y)),0.0);
}
_6656=_6655;
}
else
{
float _6654;
if ((2.0*(b.y-0.5))==1.0)
{
_6654=2.0*(b.y-0.5);
}
else
{
_6654=min(a.y/(1.0-(2.0*(b.y-0.5))),1.0);
}
_6656=_6654;
}
float _6659;
if (b.z<0.5)
{
float _6658;
if ((2.0*b.z)==0.0)
{
_6658=2.0*b.z;
}
else
{
_6658=max(1.0-((1.0-a.z)/(2.0*b.z)),0.0);
}
_6659=_6658;
}
else
{
float _6657;
if ((2.0*(b.z-0.5))==1.0)
{
_6657=2.0*(b.z-0.5);
}
else
{
_6657=min(a.z/(1.0-(2.0*(b.z-0.5))),1.0);
}
_6659=_6657;
}
return vec3(_6653,_6656,_6659);
}
#else
{
#if (BLEND_MODE_PIN_LIGHT)
{
float _6648;
if (b.x<0.5)
{
_6648=min(a.x,2.0*b.x);
}
else
{
_6648=max(a.x,2.0*(b.x-0.5));
}
float _6649;
if (b.y<0.5)
{
_6649=min(a.y,2.0*b.y);
}
else
{
_6649=max(a.y,2.0*(b.y-0.5));
}
float _6650;
if (b.z<0.5)
{
_6650=min(a.z,2.0*b.z);
}
else
{
_6650=max(a.z,2.0*(b.z-0.5));
}
return vec3(_6648,_6649,_6650);
}
#else
{
#if (BLEND_MODE_HARD_MIX)
{
float _6641;
if (b.x<0.5)
{
float _6640;
if ((2.0*b.x)==0.0)
{
_6640=2.0*b.x;
}
else
{
_6640=max(1.0-((1.0-a.x)/(2.0*b.x)),0.0);
}
_6641=_6640;
}
else
{
float _6639;
if ((2.0*(b.x-0.5))==1.0)
{
_6639=2.0*(b.x-0.5);
}
else
{
_6639=min(a.x/(1.0-(2.0*(b.x-0.5))),1.0);
}
_6641=_6639;
}
bool _2812=_6641<0.5;
float _6644;
if (b.y<0.5)
{
float _6643;
if ((2.0*b.y)==0.0)
{
_6643=2.0*b.y;
}
else
{
_6643=max(1.0-((1.0-a.y)/(2.0*b.y)),0.0);
}
_6644=_6643;
}
else
{
float _6642;
if ((2.0*(b.y-0.5))==1.0)
{
_6642=2.0*(b.y-0.5);
}
else
{
_6642=min(a.y/(1.0-(2.0*(b.y-0.5))),1.0);
}
_6644=_6642;
}
bool _2866=_6644<0.5;
float _6647;
if (b.z<0.5)
{
float _6646;
if ((2.0*b.z)==0.0)
{
_6646=2.0*b.z;
}
else
{
_6646=max(1.0-((1.0-a.z)/(2.0*b.z)),0.0);
}
_6647=_6646;
}
else
{
float _6645;
if ((2.0*(b.z-0.5))==1.0)
{
_6645=2.0*(b.z-0.5);
}
else
{
_6645=min(a.z/(1.0-(2.0*(b.z-0.5))),1.0);
}
_6647=_6645;
}
return vec3(_2812 ? 0.0 : 1.0,_2866 ? 0.0 : 1.0,(_6647<0.5) ? 0.0 : 1.0);
}
#else
{
#if (BLEND_MODE_HARD_REFLECT)
{
float _6636;
if (b.x==1.0)
{
_6636=b.x;
}
else
{
_6636=min((a.x*a.x)/(1.0-b.x),1.0);
}
float _6637;
if (b.y==1.0)
{
_6637=b.y;
}
else
{
_6637=min((a.y*a.y)/(1.0-b.y),1.0);
}
float _6638;
if (b.z==1.0)
{
_6638=b.z;
}
else
{
_6638=min((a.z*a.z)/(1.0-b.z),1.0);
}
return vec3(_6636,_6637,_6638);
}
#else
{
#if (BLEND_MODE_HARD_GLOW)
{
float _6633;
if (a.x==1.0)
{
_6633=a.x;
}
else
{
_6633=min((b.x*b.x)/(1.0-a.x),1.0);
}
float _6634;
if (a.y==1.0)
{
_6634=a.y;
}
else
{
_6634=min((b.y*b.y)/(1.0-a.y),1.0);
}
float _6635;
if (a.z==1.0)
{
_6635=a.z;
}
else
{
_6635=min((b.z*b.z)/(1.0-a.z),1.0);
}
return vec3(_6633,_6634,_6635);
}
#else
{
#if (BLEND_MODE_HARD_PHOENIX)
{
return (min(a,b)-max(a,b))+vec3(1.0);
}
#else
{
#if (BLEND_MODE_HUE)
{
vec3 _3074=a;
vec3 _3076=b;
vec4 _6629;
if (_3074.y<_3074.z)
{
_6629=vec4(_3074.zy,-1.0,0.666667);
}
else
{
_6629=vec4(_3074.yz,0.0,-0.333333);
}
vec4 _6630;
if (_3074.x<_6629.x)
{
_6630=vec4(_6629.xy,_6898,_3074.x);
}
else
{
_6630=vec4(_3074.x,_6629.y,_6898,_6629.x);
}
float _6147=_6630.x-min(_6630.w,_6630.y);
float _6072=_6630.x-(_6147*0.5);
float _6078=abs((2.0*_6072)-1.0);
vec4 _6631;
if (_3076.y<_3076.z)
{
_6631=vec4(_3076.zy,-1.0,0.666667);
}
else
{
_6631=vec4(_3076.yz,0.0,-0.333333);
}
vec4 _6632;
if (_3076.x<_6631.x)
{
_6632=vec4(_6631.xyw,_3076.x);
}
else
{
_6632=vec4(_3076.x,_6631.yzx);
}
float _6308=6.0*abs(((_6632.w-_6632.y)/((6.0*(_6632.x-min(_6632.w,_6632.y)))+1e-07))+_6632.z);
return ((clamp(vec3(abs(_6308-3.0)-1.0,2.0-abs(_6308-2.0),2.0-abs(_6308-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-_6078)*(_6147/(1.0-_6078))))+vec3(_6072);
}
#else
{
#if (BLEND_MODE_SATURATION)
{
vec3 _3084=a;
vec3 _3086=b;
vec4 _6625;
if (_3084.y<_3084.z)
{
_6625=vec4(_3084.zy,-1.0,0.666667);
}
else
{
_6625=vec4(_3084.yz,0.0,-0.333333);
}
vec4 _6626;
if (_3084.x<_6625.x)
{
_6626=vec4(_6625.xyw,_3084.x);
}
else
{
_6626=vec4(_3084.x,_6625.yzx);
}
float _5860=_6626.x-min(_6626.w,_6626.y);
float _5785=_6626.x-(_5860*0.5);
vec4 _6627;
if (_3086.y<_3086.z)
{
_6627=vec4(_3086.zy,-1.0,0.666667);
}
else
{
_6627=vec4(_3086.yz,0.0,-0.333333);
}
vec4 _6628;
if (_3086.x<_6627.x)
{
_6628=vec4(_6627.xy,_6898,_3086.x);
}
else
{
_6628=vec4(_3086.x,_6627.y,_6898,_6627.x);
}
float _5968=_6628.x-min(_6628.w,_6628.y);
float _6021=6.0*abs(((_6626.w-_6626.y)/((6.0*_5860)+1e-07))+_6626.z);
return ((clamp(vec3(abs(_6021-3.0)-1.0,2.0-abs(_6021-2.0),2.0-abs(_6021-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_5785)-1.0))*(_5968/(1.0-abs((2.0*(_6628.x-(_5968*0.5)))-1.0)))))+vec3(_5785);
}
#else
{
#if (BLEND_MODE_COLOR)
{
vec3 _3094=a;
vec3 _3096=b;
vec4 _6621;
if (_3096.y<_3096.z)
{
_6621=vec4(_3096.zy,-1.0,0.666667);
}
else
{
_6621=vec4(_3096.yz,0.0,-0.333333);
}
vec4 _6622;
if (_3096.x<_6621.x)
{
_6622=vec4(_6621.xyw,_3096.x);
}
else
{
_6622=vec4(_3096.x,_6621.yzx);
}
float _5573=_6622.x-min(_6622.w,_6622.y);
vec4 _6623;
if (_3094.y<_3094.z)
{
_6623=vec4(_3094.zy,-1.0,0.666667);
}
else
{
_6623=vec4(_3094.yz,0.0,-0.333333);
}
vec4 _6624;
if (_3094.x<_6623.x)
{
_6624=vec4(_6623.xy,_6898,_3094.x);
}
else
{
_6624=vec4(_3094.x,_6623.y,_6898,_6623.x);
}
float _5606=_6624.x-((_6624.x-min(_6624.w,_6624.y))*0.5);
float _5734=6.0*abs(((_6622.w-_6622.y)/((6.0*_5573)+1e-07))+_6622.z);
return ((clamp(vec3(abs(_5734-3.0)-1.0,2.0-abs(_5734-2.0),2.0-abs(_5734-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_5606)-1.0))*(_5573/(1.0-abs((2.0*(_6622.x-(_5573*0.5)))-1.0)))))+vec3(_5606);
}
#else
{
#if (BLEND_MODE_LUMINOSITY)
{
vec3 _3104=a;
vec3 _3106=b;
vec4 _6617;
if (_3104.y<_3104.z)
{
_6617=vec4(_3104.zy,-1.0,0.666667);
}
else
{
_6617=vec4(_3104.yz,0.0,-0.333333);
}
vec4 _6618;
if (_3104.x<_6617.x)
{
_6618=vec4(_6617.xyw,_3104.x);
}
else
{
_6618=vec4(_3104.x,_6617.yzx);
}
float _5286=_6618.x-min(_6618.w,_6618.y);
vec4 _6619;
if (_3106.y<_3106.z)
{
_6619=vec4(_3106.zy,-1.0,0.666667);
}
else
{
_6619=vec4(_3106.yz,0.0,-0.333333);
}
vec4 _6620;
if (_3106.x<_6619.x)
{
_6620=vec4(_6619.xy,_6898,_3106.x);
}
else
{
_6620=vec4(_3106.x,_6619.y,_6898,_6619.x);
}
float _5319=_6620.x-((_6620.x-min(_6620.w,_6620.y))*0.5);
float _5447=6.0*abs(((_6618.w-_6618.y)/((6.0*_5286)+1e-07))+_6618.z);
return ((clamp(vec3(abs(_5447-3.0)-1.0,2.0-abs(_5447-2.0),2.0-abs(_5447-4.0)),vec3(0.0),vec3(1.0))-vec3(0.5))*((1.0-abs((2.0*_5319)-1.0))*(_5286/(1.0-abs((2.0*(_6618.x-(_5286*0.5)))-1.0)))))+vec3(_5319);
}
#else
{
return vec3(0.0);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}

vec4 ngsPixelShader(inout vec4 result)
{
#if (sc_ProjectiveShadowsCaster)
{
vec4 param=result;
return evaluateShadowCasterColor(param);
}
#else
{
#if (sc_BlendMode_Custom)
{
vec3 _4608=getFramebufferColor().xyz;
vec3 _4603=_4608;
vec3 _4604=result.xyz;
vec3 _4621=mix(_4608,definedBlend(_4603,_4604).xyz,vec3(result.w));
vec4 _6561=vec4(_4621.x,_4621.y,_4621.z,_6865.w);
_6561.w=1.0;
result=_6561;
}
#else
{
#if (sc_BlendMode_MultiplyOriginal)
{
vec3 _3906=mix(vec3(1.0),result.xyz,vec3(result.w));
result=vec4(_3906.x,_3906.y,_3906.z,result.w);
}
#else
{
#if (sc_BlendMode_Screen)
{
vec3 _3916=result.xyz*result.w;
result=vec4(_3916.x,_3916.y,_3916.z,result.w);
}
#endif
}
#endif
}
#endif
return result;
}
#endif
}

float getFrontLayerZTestEpsilon()
{
#if (sc_SkinBonesCount>0)
{
return 5e-07;
}
#else
{
return 5e-08;
}
#endif
}

float getDepthOrderingEpsilon()
{
#if (sc_SkinBonesCount>0)
{
return 0.001;
}
#else
{
return 0.0;
}
#endif
}

float viewSpaceDepth()
{
#if (UseViewSpaceDepthVariant&&((sc_OITDepthGatherPass||sc_OITCompositingPass)||sc_OITDepthBoundsPass))
{
return varViewSpaceDepth;
}
#else
{
return sc_ProjectionMatrixArray[sc_GetStereoViewIndex()][3].z/(sc_ProjectionMatrixArray[sc_GetStereoViewIndex()][2].z+((gl_FragCoord.z*2.0)-1.0));
}
#endif
}

void oitCompositing(vec4 materialColor)
{
#if (sc_OITCompositingPass)
{
vec2 _3441=getScreenUV();
#if (sc_OITMaxLayers4Plus1)
{
if ((gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,_3441).x)<=getFrontLayerZTestEpsilon())
{
discard;
}
}
#endif
int depths[8];
int alphas[8];
for (int _6679=0; _6679<8; depths[_6679]=0,alphas[_6679]=0,_6679++)
{
}
int _6682;
#if (sc_OITMaxLayers8)
{
_6682=2;
}
#else
{
_6682=1;
}
#endif
vec4 _6693;
vec4 _6700;
vec4 _6757;
_6757=_6697;
_6700=_6697;
_6693=_6697;
vec4 _6691;
vec4 _6698;
vec4 _6755;
for (int _6680=0; _6680<_6682; _6757=_6755,_6700=_6698,_6693=_6691,_6680++)
{
vec4 _6692;
vec4 _6699;
vec4 _6756;
if (_6680==0)
{
_6756=texture2D(sc_OITAlpha0,_3441);
_6699=texture2D(sc_OITDepthLow0,_3441);
_6692=texture2D(sc_OITDepthHigh0,_3441);
}
else
{
_6756=_6757;
_6699=_6700;
_6692=_6693;
}
if (_6680==1)
{
_6755=texture2D(sc_OITAlpha1,_3441);
_6698=texture2D(sc_OITDepthLow1,_3441);
_6691=texture2D(sc_OITDepthHigh1,_3441);
}
else
{
_6755=_6756;
_6698=_6699;
_6691=_6692;
}
if (any(notEqual(_6691,vec4(0.0)))||any(notEqual(_6698,vec4(0.0))))
{
int param[8];
param[0]=depths[0];
param[1]=depths[1];
param[2]=depths[2];
param[3]=depths[3];
param[4]=depths[4];
param[5]=depths[5];
param[6]=depths[6];
param[7]=depths[7];
#if (sc_OITCompositingPass)
{
int _6705=((_6680+1)*4)-1;
float _6801=floor((_6691.w*255.0)+0.5);
for (; _6705>=(_6680*4); param[_6705]=(param[_6705]*4)+int(floor(mod(_6801,4.0))),_6801=floor(_6801*0.25),_6705--)
{
}
}
#endif
depths[0]=param[0];
depths[1]=param[1];
depths[2]=param[2];
depths[3]=param[3];
depths[4]=param[4];
depths[5]=param[5];
depths[6]=param[6];
depths[7]=param[7];
int param_1[8];
param_1[0]=param[0];
param_1[1]=param[1];
param_1[2]=param[2];
param_1[3]=param[3];
param_1[4]=param[4];
param_1[5]=param[5];
param_1[6]=param[6];
param_1[7]=param[7];
#if (sc_OITCompositingPass)
{
int _6710=((_6680+1)*4)-1;
float _6800=floor((_6691.z*255.0)+0.5);
for (; _6710>=(_6680*4); param_1[_6710]=(param_1[_6710]*4)+int(floor(mod(_6800,4.0))),_6800=floor(_6800*0.25),_6710--)
{
}
}
#endif
depths[0]=param_1[0];
depths[1]=param_1[1];
depths[2]=param_1[2];
depths[3]=param_1[3];
depths[4]=param_1[4];
depths[5]=param_1[5];
depths[6]=param_1[6];
depths[7]=param_1[7];
int param_2[8];
param_2[0]=param_1[0];
param_2[1]=param_1[1];
param_2[2]=param_1[2];
param_2[3]=param_1[3];
param_2[4]=param_1[4];
param_2[5]=param_1[5];
param_2[6]=param_1[6];
param_2[7]=param_1[7];
#if (sc_OITCompositingPass)
{
int _6715=((_6680+1)*4)-1;
float _6799=floor((_6691.y*255.0)+0.5);
for (; _6715>=(_6680*4); param_2[_6715]=(param_2[_6715]*4)+int(floor(mod(_6799,4.0))),_6799=floor(_6799*0.25),_6715--)
{
}
}
#endif
depths[0]=param_2[0];
depths[1]=param_2[1];
depths[2]=param_2[2];
depths[3]=param_2[3];
depths[4]=param_2[4];
depths[5]=param_2[5];
depths[6]=param_2[6];
depths[7]=param_2[7];
int param_3[8];
param_3[0]=param_2[0];
param_3[1]=param_2[1];
param_3[2]=param_2[2];
param_3[3]=param_2[3];
param_3[4]=param_2[4];
param_3[5]=param_2[5];
param_3[6]=param_2[6];
param_3[7]=param_2[7];
#if (sc_OITCompositingPass)
{
int _6720=((_6680+1)*4)-1;
float _6798=floor((_6691.x*255.0)+0.5);
for (; _6720>=(_6680*4); param_3[_6720]=(param_3[_6720]*4)+int(floor(mod(_6798,4.0))),_6798=floor(_6798*0.25),_6720--)
{
}
}
#endif
depths[0]=param_3[0];
depths[1]=param_3[1];
depths[2]=param_3[2];
depths[3]=param_3[3];
depths[4]=param_3[4];
depths[5]=param_3[5];
depths[6]=param_3[6];
depths[7]=param_3[7];
int param_4[8];
param_4[0]=param_3[0];
param_4[1]=param_3[1];
param_4[2]=param_3[2];
param_4[3]=param_3[3];
param_4[4]=param_3[4];
param_4[5]=param_3[5];
param_4[6]=param_3[6];
param_4[7]=param_3[7];
#if (sc_OITCompositingPass)
{
int _6731=((_6680+1)*4)-1;
float _6797=floor((_6698.w*255.0)+0.5);
for (; _6731>=(_6680*4); param_4[_6731]=(param_4[_6731]*4)+int(floor(mod(_6797,4.0))),_6797=floor(_6797*0.25),_6731--)
{
}
}
#endif
depths[0]=param_4[0];
depths[1]=param_4[1];
depths[2]=param_4[2];
depths[3]=param_4[3];
depths[4]=param_4[4];
depths[5]=param_4[5];
depths[6]=param_4[6];
depths[7]=param_4[7];
int param_5[8];
param_5[0]=param_4[0];
param_5[1]=param_4[1];
param_5[2]=param_4[2];
param_5[3]=param_4[3];
param_5[4]=param_4[4];
param_5[5]=param_4[5];
param_5[6]=param_4[6];
param_5[7]=param_4[7];
#if (sc_OITCompositingPass)
{
int _6736=((_6680+1)*4)-1;
float _6796=floor((_6698.z*255.0)+0.5);
for (; _6736>=(_6680*4); param_5[_6736]=(param_5[_6736]*4)+int(floor(mod(_6796,4.0))),_6796=floor(_6796*0.25),_6736--)
{
}
}
#endif
depths[0]=param_5[0];
depths[1]=param_5[1];
depths[2]=param_5[2];
depths[3]=param_5[3];
depths[4]=param_5[4];
depths[5]=param_5[5];
depths[6]=param_5[6];
depths[7]=param_5[7];
int param_6[8];
param_6[0]=param_5[0];
param_6[1]=param_5[1];
param_6[2]=param_5[2];
param_6[3]=param_5[3];
param_6[4]=param_5[4];
param_6[5]=param_5[5];
param_6[6]=param_5[6];
param_6[7]=param_5[7];
#if (sc_OITCompositingPass)
{
int _6741=((_6680+1)*4)-1;
float _6795=floor((_6698.y*255.0)+0.5);
for (; _6741>=(_6680*4); param_6[_6741]=(param_6[_6741]*4)+int(floor(mod(_6795,4.0))),_6795=floor(_6795*0.25),_6741--)
{
}
}
#endif
depths[0]=param_6[0];
depths[1]=param_6[1];
depths[2]=param_6[2];
depths[3]=param_6[3];
depths[4]=param_6[4];
depths[5]=param_6[5];
depths[6]=param_6[6];
depths[7]=param_6[7];
int param_7[8];
param_7[0]=param_6[0];
param_7[1]=param_6[1];
param_7[2]=param_6[2];
param_7[3]=param_6[3];
param_7[4]=param_6[4];
param_7[5]=param_6[5];
param_7[6]=param_6[6];
param_7[7]=param_6[7];
#if (sc_OITCompositingPass)
{
int _6746=((_6680+1)*4)-1;
float _6794=floor((_6698.x*255.0)+0.5);
for (; _6746>=(_6680*4); param_7[_6746]=(param_7[_6746]*4)+int(floor(mod(_6794,4.0))),_6794=floor(_6794*0.25),_6746--)
{
}
}
#endif
depths[0]=param_7[0];
depths[1]=param_7[1];
depths[2]=param_7[2];
depths[3]=param_7[3];
depths[4]=param_7[4];
depths[5]=param_7[5];
depths[6]=param_7[6];
depths[7]=param_7[7];
int param_8[8];
param_8[0]=alphas[0];
param_8[1]=alphas[1];
param_8[2]=alphas[2];
param_8[3]=alphas[3];
param_8[4]=alphas[4];
param_8[5]=alphas[5];
param_8[6]=alphas[6];
param_8[7]=alphas[7];
#if (sc_OITCompositingPass)
{
int _6771=((_6680+1)*4)-1;
float _6793=floor((_6755.w*255.0)+0.5);
for (; _6771>=(_6680*4); param_8[_6771]=(param_8[_6771]*4)+int(floor(mod(_6793,4.0))),_6793=floor(_6793*0.25),_6771--)
{
}
}
#endif
alphas[0]=param_8[0];
alphas[1]=param_8[1];
alphas[2]=param_8[2];
alphas[3]=param_8[3];
alphas[4]=param_8[4];
alphas[5]=param_8[5];
alphas[6]=param_8[6];
alphas[7]=param_8[7];
int param_9[8];
param_9[0]=param_8[0];
param_9[1]=param_8[1];
param_9[2]=param_8[2];
param_9[3]=param_8[3];
param_9[4]=param_8[4];
param_9[5]=param_8[5];
param_9[6]=param_8[6];
param_9[7]=param_8[7];
#if (sc_OITCompositingPass)
{
int _6776=((_6680+1)*4)-1;
float _6792=floor((_6755.z*255.0)+0.5);
for (; _6776>=(_6680*4); param_9[_6776]=(param_9[_6776]*4)+int(floor(mod(_6792,4.0))),_6792=floor(_6792*0.25),_6776--)
{
}
}
#endif
alphas[0]=param_9[0];
alphas[1]=param_9[1];
alphas[2]=param_9[2];
alphas[3]=param_9[3];
alphas[4]=param_9[4];
alphas[5]=param_9[5];
alphas[6]=param_9[6];
alphas[7]=param_9[7];
int param_10[8];
param_10[0]=param_9[0];
param_10[1]=param_9[1];
param_10[2]=param_9[2];
param_10[3]=param_9[3];
param_10[4]=param_9[4];
param_10[5]=param_9[5];
param_10[6]=param_9[6];
param_10[7]=param_9[7];
#if (sc_OITCompositingPass)
{
int _6781=((_6680+1)*4)-1;
float _6791=floor((_6755.y*255.0)+0.5);
for (; _6781>=(_6680*4); param_10[_6781]=(param_10[_6781]*4)+int(floor(mod(_6791,4.0))),_6791=floor(_6791*0.25),_6781--)
{
}
}
#endif
alphas[0]=param_10[0];
alphas[1]=param_10[1];
alphas[2]=param_10[2];
alphas[3]=param_10[3];
alphas[4]=param_10[4];
alphas[5]=param_10[5];
alphas[6]=param_10[6];
alphas[7]=param_10[7];
int param_11[8];
param_11[0]=param_10[0];
param_11[1]=param_10[1];
param_11[2]=param_10[2];
param_11[3]=param_10[3];
param_11[4]=param_10[4];
param_11[5]=param_10[5];
param_11[6]=param_10[6];
param_11[7]=param_10[7];
#if (sc_OITCompositingPass)
{
int _6786=((_6680+1)*4)-1;
float _6790=floor((_6755.x*255.0)+0.5);
for (; _6786>=(_6680*4); param_11[_6786]=(param_11[_6786]*4)+int(floor(mod(_6790,4.0))),_6790=floor(_6790*0.25),_6786--)
{
}
}
#endif
alphas[0]=param_11[0];
alphas[1]=param_11[1];
alphas[2]=param_11[2];
alphas[3]=param_11[3];
alphas[4]=param_11[4];
alphas[5]=param_11[5];
alphas[6]=param_11[6];
alphas[7]=param_11[7];
}
continue;
}
mediump vec4 _5078=texture2D(sc_OITFilteredDepthBoundsTexture,_3441);
int _6686;
#if (sc_SkinBonesCount>0)
{
float _5088=(1.0-_5078.x)*1000.0;
_6686=int(clamp(((_5088+getDepthOrderingEpsilon())-_5088)/((_5078.y*1000.0)-_5088),0.0,1.0)*65535.0);
}
#else
{
_6686=0;
}
#endif
float _5125=(1.0-_5078.x)*1000.0;
vec4 _6684;
_6684=materialColor*materialColor.w;
vec4 _6829;
for (int _6683=0; _6683<8; _6684=_6829,_6683++)
{
int _3678=depths[_6683];
int _3681=int(clamp((viewSpaceDepth()-_5125)/((_5078.y*1000.0)-_5125),0.0,1.0)*65535.0)-_6686;
bool _3682=_3678<_3681;
bool _3689;
if (_3682)
{
_3689=depths[_6683]>0;
}
else
{
_3689=_3682;
}
if (_3689)
{
vec3 _3700=_6684.xyz*(1.0-(float(alphas[_6683])*0.00392157));
_6829=vec4(_3700.x,_3700.y,_3700.z,_6684.w);
}
else
{
_6829=_6684;
}
continue;
}
vec4 param_12=_6684;
sc_writeFragData0(param_12);
#if (sc_OITMaxLayersVisualizeLayerCount)
{
discard;
}
#endif
}
#endif
}

float packValue(inout int value)
{
#if (sc_OITDepthGatherPass)
{
int _3255=value;
value/=4;
return floor(floor(mod(float(_3255),4.0))*64.0)*0.00392157;
}
#else
{
return 0.0;
}
#endif
}

void oitDepthGather(vec4 materialColor)
{
#if (sc_OITDepthGatherPass)
{
vec2 _3311=getScreenUV();
#if (sc_OITMaxLayers4Plus1)
{
if ((gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,_3311).x)<=getFrontLayerZTestEpsilon())
{
discard;
}
}
#endif
mediump vec4 _5148=texture2D(sc_OITFilteredDepthBoundsTexture,_3311);
float _5158=(1.0-_5148.x)*1000.0;
int param=int(clamp((viewSpaceDepth()-_5158)/((_5148.y*1000.0)-_5158),0.0,1.0)*65535.0);
float _3349=packValue(param);
vec4 _6517=_6676;
_6517.x=_3349;
int param_1=param;
float _3354=packValue(param_1);
vec4 _6519=_6517;
_6519.y=_3354;
int param_2=param_1;
float _3359=packValue(param_2);
vec4 _6521=_6519;
_6521.z=_3359;
int param_3=param_2;
float _3364=packValue(param_3);
vec4 _6523=_6521;
_6523.w=_3364;
int param_4=param_3;
float _3370=packValue(param_4);
vec4 _6525=_6676;
_6525.x=_3370;
int param_5=param_4;
float _3375=packValue(param_5);
vec4 _6527=_6525;
_6527.y=_3375;
int param_6=param_5;
float _3380=packValue(param_6);
vec4 _6529=_6527;
_6529.z=_3380;
int param_7=param_6;
float _3385=packValue(param_7);
vec4 _6531=_6529;
_6531.w=_3385;
int param_8=int(materialColor.w*255.0);
float _3391=packValue(param_8);
vec4 _6533=_6676;
_6533.x=_3391;
int param_9=param_8;
float _3396=packValue(param_9);
vec4 _6535=_6533;
_6535.y=_3396;
int param_10=param_9;
float _3401=packValue(param_10);
vec4 _6537=_6535;
_6537.z=_3401;
int param_11=param_10;
float _3406=packValue(param_11);
vec4 _6539=_6537;
_6539.w=_3406;
vec4 param_12=_6531;
sc_writeFragData0(param_12);
vec4 param_13=_6523;
sc_writeFragData1(param_13);
vec4 param_14=_6539;
sc_writeFragData2(param_14);
#if (sc_OITMaxLayersVisualizeLayerCount)
{
vec4 param_15=vec4(0.00392157,0.0,0.0,0.0);
sc_writeFragData2(param_15);
}
#endif
}
#endif
}

void main()
{
float _6592;
if (overrideTimeEnable)
{
_6592=overrideTimeElapsed;
}
else
{
_6592=sc_Time.x;
}
float _6593;
if (overrideTimeEnable)
{
_6593=overrideTimeDelta;
}
else
{
_6593=sc_Time.y;
}
vec2 _6337=_6596;
_6337.x=Interpolator0.x;
vec2 _6339=_6337;
_6339.y=Interpolator0.y;
vec2 param=_6339;
ssGlobals param_2=ssGlobals(_6592,_6593,_6599);
vec4 param_1;
Node2_Texture_2D_Parameter(param,param_1,param_2);
vec4 _6341=vec4(param_1.x,param_1.y,param_1.z,vec4(0.0).w);
_6341.w=1.0;
#if (sc_BlendMode_AlphaTest)
{
if (1.0<alphaTestThreshold)
{
discard;
}
}
#endif
#if (ENABLE_STIPPLE_PATTERN_TEST)
{
if (1.0<((mod(dot(floor(mod(gl_FragCoord.xy,vec2(4.0))),vec2(4.0,1.0))*9.0,16.0)+1.0)*0.0588235))
{
discard;
}
}
#endif
vec4 param_3=_6341;
vec4 _4343=ngsPixelShader(param_3);
vec4 _4346=max(_4343,vec4(0.0));
vec4 param_4=_4346;
sc_writeFragData0(param_4);
vec4 _4519=clamp(_4346,vec4(0.0),vec4(1.0));
#if (sc_OITDepthBoundsPass)
{
#if (sc_OITDepthBoundsPass)
{
float _4579=clamp(viewSpaceDepth()*0.001,0.0,1.0);
vec4 _4574=vec4(max(0.0,1.00392-_4579),min(1.0,_4579+0.00392157),0.0,0.0);
sc_writeFragData0(_4574);
}
#endif
}
#else
{
#if (sc_OITDepthPrepass)
{
vec4 _4569=vec4(1.0);
sc_writeFragData0(_4569);
}
#else
{
#if (sc_OITDepthGatherPass)
{
vec4 _4511=_4519;
oitDepthGather(_4511);
}
#else
{
#if (sc_OITCompositingPass)
{
vec4 _4512=_4519;
oitCompositing(_4512);
}
#else
{
#if (sc_OITFrontLayerPass)
{
#if (sc_OITFrontLayerPass)
{
if (abs(gl_FragCoord.z-texture2D(sc_OITFrontDepthTexture,getScreenUV()).x)>getFrontLayerZTestEpsilon())
{
discard;
}
vec4 _4547=_4519;
sc_writeFragData0(_4547);
}
#endif
}
#else
{
vec4 _4514=_4519;
sc_writeFragData0(_4514);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
